/*
 2010-07-16, Hiroki Ichikawa
 */
/* 
 参考文献
 GLUTによる「手抜き」OpenGL入門 床井浩平 
 GLUTによるOpenGL 入門2 テクスチャマッピング 床井浩平
 */

// iPad対応：画面の左上のタップで最大化、左下でアニメーション 2010-06-19 by Saito-A

// #define USE_GLUI // glui
#define MACINTOSH //mac
// #define WINDOWS

#define JITENSOKUDOMAX 200
#define ANIMSOKUDOMAX 30
#define ANIMSOKUDOMIN -30
#define JITENSOKUDOMIN -200


#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>


#include <iostream>
#include <fstream>
#include <string>
#include <new>

#ifdef MACINTOSH
#include <GLUT/glut.h>
#endif
#ifdef WINDOWS
# include "GL/glut.h"
#endif  

#include "ckkparam.h"
using namespace std;


int window1;
char* image3;
int window2;
int ntime2  = -50000;
/* 画像 */
TexImage image1[NUMBER_TEXTURE_FILE];
TexImage image2[NUMBER_TEXTURE_FILE]; //ロゴ

TexImage icon[NUMBER_ICON_TEXTURE_FILE]; // playicon,iconstop; // stopicon // modoruicon
TexImage pushed_icon;
int mask_logo[NUMBER_TEXTURE_FILE] ; //ロゴ画像があるかないか0無し1あり
/////////////////////
/* 光源の位置 */
GLfloat pos[] = { 0.0, 0.0, 1.0, 0.0 }; /* 光源の位置　　　 */

/* 視点の位置*/
GLdouble ex = 0.0, ey = 0.0 , ez = 20.0;

/* 目標点の位置 */
GLdouble tx = 0.0, ty = 0.0, tz = 0.0;

// gluOrthoの引数
GLdouble size_ortho =2.0; // 領域の広さ（一番上が2、下が-2）

// gluPerspetiveの引数
GLdouble fovy ; // void init で計算している
GLdouble nearlimit =0.1; // 近くの制限 gluOrthoと共通
GLdouble farlimit =40.0; // 遠くの制限 gluOrthoと共通（void init で値を計算） 


/* ドラッグ開始位置 */
int cx, cy;

/* マウスの絶対位置→ウィンドウ内での相対位置の換算係数 */
double sx, sy;


/* 回転の初期値 (クォータニオン) */
double cq[4] = { 1.0, 0.0, 0.0, 0.0 };
double cq2[4] = { 1.0, 0.0, 0.0, 0.0 };

/* ドラッグ中の回転 (クォータニオン) */
double tq[4];
double tq2[4];

/* 地球一と二のズレ (クォータニオン) */
double qzure[4];
double qzure_inv[4];

/* 回転の変換行列 */
double rt[16];
double rt2[16];
float rtglui[16];

GLfloat scale_factor = 1.0;  /* スケーリング値（拡大率） （地球の半径）*/
GLfloat scale_factor2 = 1.0;  /* スケーリング値（拡大率） （地球の半径）*/
GLfloat init_scale_factor = 1.0;  /* スケーリング値（拡大率）の初期値 */
GLfloat init_scale_factor2 = 1.0;  /* スケーリング値（拡大率）の初期値 */

// スクリーンの大きさ
int pixsize_x = 800;
int pixsize_y = 600;



GLfloat trans[2] = {0.0f,0.0f};
GLfloat trans2[2] = {0.0f,0.0f};
float trans_ary[2]={0.0f,0.0f};
float trans_ary2[2]={0.0f,0.0f};
float trans_aryZ[]={0};
float trans_aryZ2[]={0};
float line_width = 0.8 ;// 線（緯線、経線）の太さ
float line_width_red = 2.0 ;// 赤道の太さ


int scaling = 0;// 1はスケーリングの変更中
int parallel = 0; // 1は平行移動中
int fogornot=0; // 1はFOG処理がある
int fullscreen=0; // 1はフルスクリーン
int jitenornot=0; // 1は自転
int print_dame=0; // 1の場合、ファイルの書き出しができない
int stopornot=0; // 1は時間発展で最後までいったらくりかえす
int num_keisen =2 ; // 経線の数、初期条件ファイルを読み込む
int num_isen =2; // 緯線の数、初期条件ファイルを読み込む
int isenkeisenornot  = 0; // 1の場合、経線や緯線を表示する
int readtextureornot = 1; // 1はテクスチャファイルを読み込む
int readtextureornot2 = 1; // 1はテクスチャファイルを読み込む（ウィンドウ2） 
int readinit_file =1; // 1はinit_file、初期条件ファイルを読み込む
GLint fogMode =0;

clock_t jikan1 ; //時間計測
clock_t jikan2 ; //時間計測
clock_t jitenjikan1 ; //時間計測
clock_t jitenjikan2 ; //時間計測
int gui_posi_x =750 ,gui_posi_y =100; // GUIの窓の初期位置
double anim_speed =0.2 ; //アニメーション時にテクスチャを変更する時間間隔（秒）（標準値）
double anim_duration =0.2 ; //再生ボタンを押してからのポーズ時間
double key_kaiten = 2.0; // キーボードでの回転角の調整
double jiten_speed = 0.0001;//自転時に地球を回転する時間間隔（秒）（こっちは固定）
double jiten_kankaku = 0.3;//自転時に地球を回転する一回あたりの角度（360.0で一週）（標準値）
double rad_latitude = 0.0;// 緯度の初期値
double rad_longitude = 0.0;// 経度の初期値
double rad_latitude2 = 0.0;// 緯度の初期値
double rad_longitude2 = 0.0;// 経度の初期値
double logo_scale =3.0; // ロゴの拡大率
double logo_x = -2.5 ; // ロゴのx座標
double logo_y =1.0 ; // ロゴのy座標
double time_x = -1.0 ; // タイムバーのx座標
double time_y =-1.0 ; // タイムバーのy座標
double time_scale  = 1.0; // タイムバーの拡大率
double thetajiten = INITJITEN ; // 自転角の初期値
double trans_x = 0.0 ; // 地球の初期のx座標
double trans_y = 0.0 ; // 地球の初期のy座標
double trans_x2 = 0.0 ; // 地球2の初期のx座標
double trans_y2 = 0.0 ; // 地球2の初期のy座標
double angle_axis2[2] = {0.0,1.0} ; // 地球２の角度のずれの軸 (x,y)で指定。
double angle2 = -30.0 ; // 地球2の角度のずれ
int screen_front = 1; // 1のとき、スクリーンが地球より前、0のとき、スクリーンが後ろ


// 慣性回転関係
double kansei_speed = 0.001;//慣性回転時に地球を回転する時間間隔（秒）（こっちは固定）


clock_t kanseijikan1 ; //時間計測
clock_t kanseijikan2 ; //時間計測
double minkanseikaiten = 0.1; //この値より変化が小さい場合は慣性による回転をしない（回転の次元）
double minkanseikaitenstop = 0.01;//この値よ変化が小さくなった場合は慣性による回転を止める（回転の次元）
double strengthkanseikaiten= 0.04;//慣性回転の回転の速さ
double gensuikanseikaiten= 0.995;// 慣性回転の減衰係数（1は減衰しない） 


int invisible_cursor  = 0;// 1の場合マウスカーソルが見えない。

int ipad_frag = 0; // 1の場合ipad用
int int_button = 1;// ボタンファイルが有るかないか。1はある
int icon_onoff[NUMBER_ICON]  ={0}; // アイコンがあるかないかを指定する。1はある。0はない
double icon_scale[NUMBER_ICON] = {1.0,1.0} ; // アイコンの大きさ
double icon_posi_x[NUMBER_ICON]  = {1.5,1.8} ; // アイコンのx座標
double icon_posi_y[NUMBER_ICON]  = {-1.0,-1.0} ; // アイコンのy座標
int nsphere = 1 ; // 表示する惑星の数
int synch = 1; // 惑星の平行移動と拡大縮小がシンクロするかどうか 1はシンクする
int rotsynch = 1; // 惑星の回転がシンクロするかどうか 1はシンクする
int second_sphere_texture =0; // テクスチャを惑星によって変更する場合は、1

int animsokudo = 8; //初期値 {1~30}の値を取る
int jitensokudo = 6; //初期値 {1~30}の値を取る
int henka =0;// コントロールパネルで速度を変えたときが 1
int guilevel = 1; // GUIのレベル

std::string strtexfile ="map/sample";
std::string strtexfile2 ="map/sample";
std::string strtexfile_s ="ppm";
std::string strtexfile_s2 ="ppm";
std::string strscreenfile ="logo/sample";
std::string strscreenfile2 ="logo/panel";
std::string strscreenfile_s ="ppm";
std::string strscreenfile_s2 ="ppm";
int tex_start = 1; // 最初のテクスチャの番号（ファイル名）
int tex_end = 10; // 最後のテクスチャの番号

char *buff2 ="ppm";   /* 文字列用 （後）コマンドライン引数がない場合の文字列*/

//初期設定ファイル

char* init_file[3] = {"data/conf/init_conf.txt", "data/conf/conf.txt", ""}; 

char logobuff[128];    /* 連結文字列用 */

char *logobuff2 ="ppm";   /* 文字列用 （後）コマンドライン引数がない場合の文字列*/
FILE *gazou_f[NUMBER_TEXTURE_FILE];
FILE *logogazou_f[NUMBER_TEXTURE_FILE];

void init_rotate(void);
void fog(void);
void idle(int);
void init_glut_menu(void);


int ntime=0; //時間の初期値

int ntimemax=NUMBER_TEXTURE_FILE; //テクスチャの数（デフォルト）（時間の上限）。ファイル数によって自動的にntimemaxが決められる。
int ntimetmp =-9283734;

int perspec = 2; // 1はperspectiveに眺める
int perspec_radio =1; //ラジオボタン用
int print = 0; // 1は画像をファイルに出力する
int anim = 0; // 0 静止、1 テクスチャアニメーション 、-1　逆再生 

// 色の設定
GLfloat color_isenkeisen[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat color_sekidou[] = { 0.8f, 0.2f, 0.2f, 1.0f };
GLfloat white[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat gray[] = { 0.3f, 0.3f, 0.3f, 1.0f };
GLfloat darkgray[] = { 0.1f, 0.1f, 0.1f, 1.0f };
GLfloat green[] = { 0.0f, 1.0f, 0.0f, 1.0f };
GLfloat red[] = { 0.8f, 0.2f, 0.2f, 1.0f };
GLfloat blue[] = { 0.0f, 0.0f, 1.0f, 1.0f};

int listSphere; 

// このファイルのみの変数
double theta1;
double theta2;
double theta1_2;
double theta2_2;



double icon_posi_x_window[NUMBER_ICON][2]  ; //最初の引数はアイコンの識別、 アイコンのウインドウx座標 0は左端、1は右端
double icon_posi_y_window[NUMBER_ICON][2]   ; // 最初の引数はアイコンの識別、 アイコンのウインドウy座標 0は上端、1は下端
int pushbutton[NUMBER_ICON] = {0};
int pushedbutton[NUMBER_ICON] = {0};
int pushwindow = 0;  // どの窓でボタンを押しているか。
double arhozon =0.0,arhozon2 =0.0,dxhozon =0.0,dyhozon = 0.0,ahozon = 0.0;
double arhozon_2 =0.0,arhozon2_2 =0.0,dxhozon_2 =0.0,dyhozon_2 = 0.0,ahozon_2 = 0.0;




static GLuint texName[2]; // テクスチャオブジェクト用
static GLuint icontexName[NUMBER_ICON_TEXTURE_FILE]; // テクスチャオブジェクト用
static GLuint pushed_icontexName; // テクスチャオブジェクト用

// アイコンの効果を登録
void effect_icon(int num_icon)
{
  switch (num_icon) {
    // 再生、停止ボタン
  case 0:
      if (anim != 1){
	anim=1 ;
	
      }	else {
	anim=0;
      }
      init_glut_menu();	
      glutPostRedisplay();
    break;
    // 初期設定に戻るボタン
  case 1:
     init_rotate();
     thetajiten = INITJITEN; //自転角
     scale_factor = init_scale_factor; //大きさ
     scale_factor2 = init_scale_factor2; //大きさ
     trans[0] = trans_x;
     trans[1] = trans_y;
     trans2[0] = trans_x2;
     trans2[1] = trans_y2;
     ntime =0;
     jikan1 =clock() ;
     glutPostRedisplay();
     break;
	
     // 逆再生、停止ボタン
  case 2:
    if (anim != -1){
      anim=-1 ;
      
    }	else {
      anim=0;
    }
    init_glut_menu();	
    glutPostRedisplay();
    break;
 
     // スピンボタン
  case 3:
    if (jitenornot==0 ){
      jitenornot=1 ;
	
    }	else {
      jitenornot=0;
    }
    init_glut_menu();	
    glutPostRedisplay();
    break;
      	// forwardボタン
  case 4:
    ntime =ntime +1;
    if (ntime >= ntimemax) {
      ntime = ntimemax-1;
    }
    
    anim=0;
    
    init_glut_menu();	
    glutPostRedisplay();
    break;
	// backボタン
  case 5:
    if (ntime != 0) ntime =ntime  - 1 ;
			
    anim=0;
    
    init_glut_menu();	
    glutPostRedisplay();
    break;
    	// 経線、緯線ボタン
  case 6:
    if (isenkeisenornot==0 ){
      isenkeisenornot=1 ;
      
    }	else {
      isenkeisenornot=0;
    }
    init_glut_menu();	
    glutPostRedisplay();
    break;
	// 拡大ボタン
 case 7:
   if ( (glutGetWindow() == window1) || (synch == 1)){
     scale_factor = scale_factor*1.2;
     if (scale_factor > ez - nearlimit) scale_factor = ez - nearlimit; //　地球の内部が見えないように
   } else {
     scale_factor2 = scale_factor2*1.2;
     if (scale_factor2 > ez - nearlimit) scale_factor2 = ez - nearlimit; //　地球の内部が見えないように
   }
   
   glutPostRedisplay();
    break;
// 縮小ボタン
 case 8:
 	
   if ( (glutGetWindow() == window1) || (synch == 1)){			
     scale_factor = scale_factor*0.8333333333333;
   } else {
     scale_factor2 = scale_factor2*0.8333333333333;
   }
   glutPostRedisplay();
   
    break;
	// 地球の向きを初期条件の向きに合わせる
 case 9:
   glutPostRedisplay();
   latitude_rotate();
   glutPostRedisplay();
   break;
   
	// 再生スピードを早くボタン
 case 10:
   if (++animsokudo >= ANIMSOKUDOMAX+1) animsokudo = ANIMSOKUDOMAX;
   init_glut_menu();
   break;

	// 再生スピードを遅くボタン
 case 11:
   if (--animsokudo <= ANIMSOKUDOMIN-1) animsokudo = ANIMSOKUDOMIN;
   init_glut_menu();
   break;

    // quitボタン
  case 12:
    exit(0);
   break;


    // フルスクリーンボタン
  case 13:
    if (fullscreen==0 ){
      fullscreen=1 ;
	
      glutFullScreen();
    }	else {
      fullscreen=0;
      // アニメーション終了 
		
      cx =  cx*sx*pixsize_x;
      cy =  cy*sy*pixsize_y;
      glutReshapeWindow(pixsize_x, pixsize_y);
      
    }
    
	    
    init_glut_menu();	
    glutPostRedisplay();
    break;

  default:;
  }
}

// アイコン
void show_icon(void)
{
  for (int i = 0; i<int_button; i++) {
    // 再生ボタンなど	
    // if (int_button != 0) {
    if (icon_onoff[i] ==1){
      if ( i == 0) {
	if (anim != 1) {
	 
	  glBindTexture(GL_TEXTURE_2D,icontexName[0]);

	 
	} else {
	  glBindTexture(GL_TEXTURE_2D,icontexName[1]);
	}
	
      } else if ( i ==1) {
	glBindTexture(GL_TEXTURE_2D,icontexName[2]);
					
      }		else if ( i ==2) 	{
	if (anim != -1) {
	  glBindTexture(GL_TEXTURE_2D,icontexName[3]);
	} else				{
	  glBindTexture(GL_TEXTURE_2D,icontexName[1]);
	}	 
				
      }
						
      else if ( i ==3) {
	if (jitenornot== 0) {
	  glBindTexture(GL_TEXTURE_2D,icontexName[4]);
	}else{
	  glBindTexture(GL_TEXTURE_2D,icontexName[5]);
	}
	
      }else if ( i ==4) {
	glBindTexture(GL_TEXTURE_2D,icontexName[6]);
      				
      }else if ( i ==5) {
	glBindTexture(GL_TEXTURE_2D,icontexName[7]);
					
	

      } else if ( i ==6) {
	if (isenkeisenornot== 0) {
	  glBindTexture(GL_TEXTURE_2D,icontexName[8]);
	} else				{
	  glBindTexture(GL_TEXTURE_2D,icontexName[9]);
	 
	}
      } else if ( i ==7) {
	glBindTexture(GL_TEXTURE_2D,icontexName[10]);
      }else if ( i ==8) {
	glBindTexture(GL_TEXTURE_2D,icontexName[11]);
      }else if ( i ==9) {
	glBindTexture(GL_TEXTURE_2D,icontexName[12]);
      }else if ( i ==10) {
	glBindTexture(GL_TEXTURE_2D,icontexName[13]);
      }else if ( i ==11) {
	glBindTexture(GL_TEXTURE_2D,icontexName[14]);
      } else if ( i ==12) {
	glBindTexture(GL_TEXTURE_2D,icontexName[15]);

      } else if ( i ==13) {
	if (fullscreen ==1) {
	  glBindTexture(GL_TEXTURE_2D,icontexName[16]);
	}else{
	  glBindTexture(GL_TEXTURE_2D,icontexName[17]);
	}
      }
      
    
    

      double ratio =1.0; //  icon[0].width/icon[0].height; // 結局正方形のみを使う
     
   
    
      glEnable(GL_TEXTURE_2D);
     
      glBegin(GL_QUADS);
      
      	
      glTexCoord2d(0.0, 0.0 );
		
      glVertex3d(icon_posi_x[i],icon_posi_y[i], 0.0);
      glTexCoord2d(0.0, 1.0);
		
      glVertex3d(icon_posi_x[i],icon_posi_y[i]-icon_scale[i], 0.0);
      glTexCoord2d(1.0, 1.0);
		
      glVertex3d(icon_posi_x[i]+icon_scale[i]*ratio ,icon_posi_y[i]-icon_scale[i], 0.0);
      glTexCoord2d( 1.0, 0.0);
		
      glVertex3d(icon_posi_x[i]+icon_scale[i]*ratio,icon_posi_y[i], 0.0);
      glEnd();
      glDisable(GL_TEXTURE_2D); 

      // アイコンを押したときの効果
      if (pushbutton[i]==1) { 
	if ( pushwindow == glutGetWindow()) {
	  glBindTexture(GL_TEXTURE_2D,pushed_icontexName);
	  glEnable(GL_TEXTURE_2D);
	 
	  glBegin(GL_QUADS);
	
      	
	  glTexCoord2d(0.0, 0.0 );
	
	  glVertex3d(icon_posi_x[i],icon_posi_y[i], 0.0);
	  glTexCoord2d(0.0, 1.0);
	  
	  glVertex3d(icon_posi_x[i],icon_posi_y[i]-icon_scale[i], 0.0);
	  glTexCoord2d(1.0, 1.0);
	
	  glVertex3d(icon_posi_x[i]+icon_scale[i]*ratio ,icon_posi_y[i]-icon_scale[i], 0.0);
	  glTexCoord2d( 1.0, 0.0);
	 
	  glVertex3d(icon_posi_x[i]+icon_scale[i]*ratio,icon_posi_y[i], 0.0);
	  glEnd();
	  glDisable(GL_TEXTURE_2D); 
	}
      }
    }
  }
  // 再生ボタンなど　（ここまで）
}



//時間バー
void functimebar(void)
{
  GLdouble yoko =0.125*time_scale; //左右の四角の横
  GLdouble tate = time_scale;//左右の四角の縦
  GLdouble haba =5.0 *time_scale; //タイムバーの幅
  double jikanbar;
  double sankakuyoko =0.2*time_scale; //時間を示す四角の横
  double sankakutate =0.6*time_scale;//時間を示す四角の縦
  double yokobartate =0.125*time_scale;//中心の線の縦
	
  jikanbar = (double)ntime/(ntimemax-1)*(haba-sankakuyoko+yoko);
  glColor4fv(gray);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, gray);
  //	glMaterialfv(GL_FRONT, GL_DIFFUSE, red);
  glBegin(GL_QUADS);
  //	左の四角
  glVertex3d( time_x, time_y, 0.0);	
  glVertex3d( time_x, time_y-tate, 0.0);
  glVertex3d( time_x+yoko, time_y-tate, 0.0);
  glVertex3d( time_x+yoko, time_y, 0.0);
  //	右の四角
  glVertex3d( time_x+haba, time_y, 0.0);
  glVertex3d( time_x+haba, time_y-tate, 0.0);
  glVertex3d( time_x+haba+yoko, time_y-tate, 0.0);
  glVertex3d( time_x+haba+yoko, time_y, 0.0);
  glEnd();
	
  // タイムバー
  glBegin(GL_QUADS);
  glVertex3d( time_x+jikanbar, time_y+0.5*sankakutate-0.5*tate, 0.0);
  glVertex3d( time_x+jikanbar, time_y- 0.5*tate-0.5*sankakutate,0.0);
  glVertex3d( time_x+jikanbar+sankakuyoko, time_y- 0.5*tate-0.5*sankakutate, 0.0);
  glVertex3d( time_x+jikanbar+sankakuyoko, time_y+0.5*sankakutate-0.5*tate, 0.0);	
  glEnd();
	
  glColor4fv(darkgray);
  // 横バー
  glBegin(GL_QUADS);
  glVertex3d( time_x, time_y-0.5*tate+0.5*yokobartate, 0.0);
  glVertex3d( time_x, time_y-0.5*tate-0.5*yokobartate, 0.0);
  glVertex3d( time_x+haba+yoko, time_y-0.5*tate-0.5*yokobartate, 0.0);
  glVertex3d( time_x+haba+yoko, time_y-0.5*tate+0.5*yokobartate, 0.0);
  glEnd();
	
	
}

// fps数を計測
void getFPS()
{
  static int GLframe;
  static unsigned int GLtimebase;
  unsigned int GLtimenow;
  double fps;
  GLframe++;
  GLtimenow = glutGet(GLUT_ELAPSED_TIME);
	
  if (GLtimenow - GLtimebase > 1000) {
    fps = GLframe * 1000.0 / (GLtimenow - GLtimebase);
    GLtimebase = GLtimenow;
    GLframe = 0;
    cout << fps <<'\n';
  }
}


// num_windowはwindow番号
void display_earth(int num_window)
{
  

  glEnable(GL_DEPTH_TEST); //
  /* モデルビュー変換行列の保存 */
  glPushMatrix();
 

  // ここから、惑星の表示

 
  // gluiでの平行移動で使う
 
  trans[0] = (trans_ary[0]-trans[0])*0.0002+trans[0];
  trans[1] = (trans_ary[1]-trans[1])*0.0002+trans[1];
  trans_ary[0] = trans[0];
  trans_ary[1] = trans[1];
 
 
	
  // 慣性による回転
  if (arhozon > minkanseikaiten) {
    //   kanseijikan2 = clock();
    //  if ( (double)(kanseijikan2 - kanseijikan1) / CLOCKS_PER_SEC > kansei_speed){
    if (arhozon2 >  minkanseikaitenstop ) {
      double as = sin(arhozon2*strengthkanseikaiten) /ahozon;
      double dq[4] = { cos(arhozon2*strengthkanseikaiten), dyhozon * as, dxhozon * as, 0.0 };
			
     
//     回転の初期値 cq に dq を掛けて回転を合成 
      qmul(tq, dq, cq);
      
      cq[0] = tq[0];
      cq[1] = tq[1];
      cq[2] = tq[2];
      cq[3] = tq[3];
      //     クォータニオンから回転の変換行列を求める 
      qrot(rt, tq);
      if (rotsynch == 1) {
	qmul(tq2, qzure, tq);
	cq2[0] = tq2[0];
	cq2[1] = tq2[1];
	cq2[2] = tq2[2];
	cq2[3] = tq2[3];
	qrot(rt2, tq2);
      }
    
    
			
      for (int i = 0;i<16;i++) {
	rtglui[i] = rt[i];	 //glui用の回転
      }
      arhozon2 = arhozon2*gensuikanseikaiten;
    } else {
      // 全部ゼロにする
      arhozon = 0.0;arhozon2 = 0.0;dxhozon = 0.0;dyhozon = 0.0;
    }
    //  kanseijikan1 = clock();
    // }
		
  }

	
  // 慣性による回転(window2)
  if (arhozon_2 > minkanseikaiten) {
    //   kanseijikan2 = clock();
    //  if ( (double)(kanseijikan2 - kanseijikan1) / CLOCKS_PER_SEC > kansei_speed){
    if (arhozon2_2 >  minkanseikaitenstop ) {
      double as = sin(arhozon2_2*strengthkanseikaiten) /ahozon_2;
      double dq[4] = { cos(arhozon2_2*strengthkanseikaiten), dyhozon_2 * as, dxhozon_2 * as, 0.0 };
			
     
//     回転の初期値 cq に dq を掛けて回転を合成 
      qmul(tq2, dq, cq2);
      cq2[0] = tq2[0];
      cq2[1] = tq2[1];
      cq2[2] = tq2[2];
      cq2[3] = tq2[3];
     
      //     クォータニオンから回転の変換行列を求める 
      qrot(rt2, tq2);
      
      if (rotsynch == 1) {
	qmul(tq, qzure_inv, tq2);

	cq[0] = tq[0];
	cq[1] = tq[1];
	cq[2] = tq[2];
	cq[3] = tq[3];
	qrot(rt, tq);
      }		
      for (int i = 0;i<16;i++) {
	rtglui[i] = rt[i];	 //glui用の回転
      }
      arhozon2_2 = arhozon2_2*gensuikanseikaiten;
    } else {
      // 全部ゼロにする
      arhozon_2 = 0.0;arhozon2_2 = 0.0;dxhozon_2 = 0.0;dyhozon_2 = 0.0;
    }
    //  kanseijikan1 = clock();
    // }
		
  }

  	
/* テクスチャの割り当て */
	
  glBindTexture(GL_TEXTURE_2D,texName[0]);
 
  /* 回転 */
 
	
  glMaterialfv(GL_FRONT, GL_DIFFUSE, white);

  /* テクスチャマッピング開始 */
  glEnable(GL_TEXTURE_2D);
	
  // 自転角を計算
  if (jitenornot ==1){
    jitenjikan2 = clock();
    if ( (double)(jitenjikan2 - jitenjikan1) / CLOCKS_PER_SEC > jiten_speed){
      thetajiten= thetajiten + jiten_kankaku/100.0*jitensokudo;
      jitenjikan1 = clock();
    }
  }
 
	
  /* 球を描く */
  if (synch == 1) {scale_factor2 = scale_factor;}
 

  if (num_window == window2) {
    // ディスプレイ２
   // 二個目の惑星	
    glTranslatef((trans_x2)*(GLfloat)(scale_factor2),(trans_y2)*(GLfloat)(scale_factor2),0.0);
   
    if (synch == 1){
      glTranslatef(trans[0]*(GLfloat)(scale_factor2),trans[1]*(GLfloat)(scale_factor2),0.0);
    } else {
      glTranslatef(trans2[0]*(GLfloat)(scale_factor2),trans2[1]*(GLfloat)(scale_factor2),0.0);
    }
    //  glRotatef(angle2,angle_axis2[0],angle_axis2[1],0.0); //違う角度
  
    glMultMatrixd(rt2);
  
    glRotatef(thetajiten,0.0,0.0,1.0); 
    glScalef(scale_factor2,scale_factor2,scale_factor2);
  }
  else{
 // 平行移動
    glTranslatef(trans[0]*(GLfloat)(scale_factor),trans[1]*(GLfloat)(scale_factor),0.0);
    glMultMatrixd(rt);
    // ディスプレイ１
    glRotatef(thetajiten,0.0,0.0,1.0); //（地球の自転）ここ以降に書いた図形は回転される（z軸周り）
    glScalef(scale_factor,scale_factor,scale_factor);
  }

  sphere(1.0);
	
  glDisable(GL_TEXTURE_2D);
  /* モデルビュー変換行列の復帰 */
  glPopMatrix();
  glDepthFunc(GL_ALWAYS);
 
  functimebar();//時間バーを追加
  show_icon(); // アイコンの表示





 
  glDepthFunc(GL_LESS);

  //glCallList(listSphere);
	
  /* テクスチャマッピング終了 */

  

  glDisable(GL_DEPTH_TEST);
 


  //		glEnable(GL_LIGHTING);
	
  //glCullFace(GL_BACK); //ポリゴンの裏側を見えなくする
	
 
	
	
  //ラジオボタンでperspec_radioが変更された場合
  if (perspec_radio != perspec) {
    perspec = perspec_radio;
    resize((int)(1.0/sx),(int)(1.0/sy));
  }
  //コントロールパネルで再生速度などが変わった場合
  if (henka == 1){
    init_glut_menu();
    henka = 0;
  }
	
  
}



void display2(void)
{
  
 
  
  int pix_i, pix_j, pix_k;
  FILE *ppmf;
  GLdouble winlogox,winlogoy ;// ロゴのウィンドウサイズ
	
  char char_error_fileoutput[] = "Flie Output Error." ;
  char char_error_fileinput[] = "No Sphere Texture File." ;



  // テクスチャファイルを読み込む		
  if (readtextureornot2 == 1 ){
  
  
      fileyomitori (window2 );
      readtextureornot2 = 0;
  
  }
	
  // マウスカーソル
  if (scaling) {
    glutSetCursor(GLUT_CURSOR_UP_DOWN);
  } else {
    glutSetCursor(GLUT_CURSOR_INHERIT);
  }
	
  if (invisible_cursor == 1) 
    glutSetCursor(GLUT_CURSOR_NONE);
	
	
  //		fog();	// fog
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//画面全体を背景色で塗りつぶす 
  // テクスチャアニメーションで時間を計る
  //	 ntimeがntimemaxと同じ値になったらゼロにする。
	
	
		
  // 地球2のfullscreenがオンのときは、地球1のdisplayはcallされない。
  if (fullscreen == 1) {
    
    if (anim ==1){
      jikan2 = clock();
      double kankaku = anim_speed*pow(sqrt(2.0),(double)(8 - animsokudo));
      if (ntime == 0) kankaku = kankaku + anim_duration;
      
      if ( (double)(jikan2 - jikan1) / CLOCKS_PER_SEC > kankaku ){
	if (++ntime >= ntimemax) {
	  ntime = 0;
	  
	  if (stopornot == 0){
	    anim =0; //再生を止める
	  }
	}
	jikan1 = clock();
      }
    
    } 
    else if  (anim ==-1) {// 逆再生の場合
      jikan2 = clock();
      double kankaku = anim_speed*pow(sqrt(2.0),(double)(8- animsokudo));
      if (ntime == ntimemax-1) kankaku = kankaku + anim_duration;
      
      if ( (double)(jikan2 - jikan1) / CLOCKS_PER_SEC > kankaku){
	if (--ntime == -1){ 
	  ntime = ntimemax-1;
	  if (stopornot == 0){
	    anim =0; //再生を止める
	  }
	}
	jikan1 = clock();
      }	
		
    }
  

   
  } 


  // ntimeがntimetempと違うときテクスチャを入れ替える
 
  if (ntime2 != ntime) {
    ntime2 = ntime;
  
    texture_change(window2);
 
  }
 
  //	glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();				//単位行列を行列スタックに読み込む
	


  /* 視点の移動 */
  gluLookAt(ex, ey, ez, tx, ty, tz, 0.0, 1.0, 0.0);	
	
  //		glDisable(GL_LIGHTING); 

  // 二つ目の地球のテクスチャが違う場合
  int plus = 0;
  if (second_sphere_texture == 1) {
    plus = ntimemax;
  }

  
  if (screen_front == 1 ) display_earth(window2);
  if (mask_logo[ntime+plus]) {
    // ロゴのウインドウサイズ
    double ratio =  (GLdouble)image2[ntime+plus ].width/(GLdouble)image2[ntime+plus].height;
    winlogox= ratio*logo_scale; //最後のは拡大率
    winlogoy = logo_scale;
		
    glBindTexture(GL_TEXTURE_2D,texName[1]);
    // ロゴの表示	
    /* テクスチャの割り当て */
    //		 glTexImage2D(GL_TEXTURE_2D,0, GL_RGB, imagecv2[ntime]->width,imagecv2[ntime]->height, 0,GL_RGB,GL_UNSIGNED_BYTE,imagecv2[ntime]->imageData);
    //			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, imagecv2[ntime]->width,imagecv2[ntime]->height, GL_RGB,GL_UNSIGNED_BYTE,imagecv2[ntime]->imageData);
		
		
    glEnable(GL_TEXTURE_2D);
    glBegin(GL_QUADS);
    glTexCoord2d(0.0, 0.0 );
    glVertex3d( logo_x, logo_y, 0.0);
    glTexCoord2d(0.0, 1.0);
    glVertex3d( logo_x, logo_y-winlogoy, 0.0);
    glTexCoord2d(1.0, 1.0);
    glVertex3d(logo_x+winlogox , logo_y-winlogoy, 0.0);
    glTexCoord2d( 1.0, 0.0);
    glVertex3d( logo_x+winlogox, logo_y, 0.0);
    glEnd();
    glDisable(GL_TEXTURE_2D); 
  };
  if (screen_front == 0 ) display_earth(window2);
 
	
  glutPostRedisplay();
  glutSwapBuffers();	
       	
}

void display(void)
{
  int pix_i, pix_j, pix_k;
  FILE *ppmf;
  GLdouble winlogox,winlogoy ;// ロゴのウィンドウサイズ
	
  char char_error_fileoutput[] = "Flie Output Error." ;
  char char_error_fileinput[] = "No Sphere Texture File." ;
 

	
  // fps数を計測
#ifdef FPS
  getFPS();
#endif
	
	
  //初期設定ファイルを読み込む（基本的にはmainで呼んでいる。途中で読みたい場合に使う） 
  if(readinit_file ==1){ 
    func_readinit_file();
    readinit_file =0;
  }

		
  // テクスチャファイルを読み込む		
  if (readtextureornot == 1 ){
		
    fileyomitori (window1 );
    readtextureornot = 0;
		
  }
	
  // マウスカーソル
  if (scaling) {
    glutSetCursor(GLUT_CURSOR_UP_DOWN);
  } else {
    glutSetCursor(GLUT_CURSOR_INHERIT);
  }
	
  if (invisible_cursor == 1) 
    glutSetCursor(GLUT_CURSOR_NONE);
	
#ifdef USE_GLUI
  if (guilevel == 1)  gluiUpdate();   // Update user interface to reflect these changes
#endif
	
	
	
  //		fog();	// fog
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//画面全体を背景色で塗りつぶす 
  // テクスチャアニメーションで時間を計る
  //	 ntimeがntimemaxと同じ値になったらゼロにする。
	
  //
  //  cout << anim << '\n' ;
	
  if (anim ==1){
   
    jikan2 = clock();
    double kankaku = anim_speed*pow(sqrt(2.0),(double)(8 - animsokudo));
    if (ntime == 0) kankaku = kankaku + anim_duration;
		
    if ( (double)(jikan2 - jikan1) / CLOCKS_PER_SEC > kankaku ){
      if (++ntime >= ntimemax) {
	ntime = 0;

	if (stopornot == 0){
	  anim =0; //再生を止める
	}
      }
      jikan1 = clock();
    }
		
  } 
  else if  (anim ==-1) {// 逆再生の場合
    jikan2 = clock();
    double kankaku = anim_speed*pow(sqrt(2.0),(double)(8- animsokudo));
    if (ntime == ntimemax-1) kankaku = kankaku + anim_duration;
		
    if ( (double)(jikan2 - jikan1) / CLOCKS_PER_SEC > kankaku){
      if (--ntime == -1){ 
	ntime = ntimemax-1;
	if (stopornot == 0){
	  anim =0; //再生を止める
	}
      }
      jikan1 = clock();
    }	
		
  }
	
  // ntimeがntimetempと違うときテクスチャを入れ替える
  if (ntimetmp != ntime) {
    
    texture_change(window1);
  }
	
  //	glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();				//単位行列を行列スタックに読み込む
	


  /* 視点の移動 */
  gluLookAt(ex, ey, ez, tx, ty, tz, 0.0, 1.0, 0.0);	
	
  //		glDisable(GL_LIGHTING); 
  if (screen_front == 1 ) display_earth(window1);
  if (mask_logo[ntime]) {
    // ロゴのウインドウサイズ
    double ratio =  (GLdouble)image2[ntime].width/(GLdouble)image2[ntime].height;
    winlogox= ratio*logo_scale; //最後のは拡大率
    winlogoy = logo_scale;
		
    glBindTexture(GL_TEXTURE_2D,texName[1]);
   
		
    glEnable(GL_TEXTURE_2D);
    glBegin(GL_QUADS);
    glTexCoord2d(0.0, 0.0 );
    glVertex3d( logo_x, logo_y, 0.0);
    glTexCoord2d(0.0, 1.0);
    glVertex3d( logo_x, logo_y-winlogoy, 0.0);
    glTexCoord2d(1.0, 1.0);
    glVertex3d(logo_x+winlogox , logo_y-winlogoy, 0.0);
    glTexCoord2d( 1.0, 0.0);
    glVertex3d( logo_x+winlogox, logo_y, 0.0);
    glEnd();
    glDisable(GL_TEXTURE_2D); 
  };
  if (screen_front == 0 ) display_earth(window1);

  glutPostRedisplay();
  glutSwapBuffers();
 

  ntimetmp= ntime;
	
	
}

void resize(int w, int h)
{
  /* マウスポインタ位置のウィンドウ内の相対的位置への換算用 */
  sx = 1.0 / (double)w;
  sy = 1.0 / (double)h;
  /*          縦横比                  */	
  double ratio = (double)w / (double)h;
  /* ウィンドウ全体をビューポートにする */
  glViewport(0, 0, w, h);
	
  /* 透視変換行列の指定 */
  glMatrixMode(GL_PROJECTION);
	
  /* 透視変換行列の初期化 */
  glLoadIdentity();
	
  if (perspec == 1){
    gluPerspective(fovy,ratio, nearlimit, farlimit);
  }	else {
    //	glOrtho(-3.1*(double)w /pixsize_x*ratio,3.1*(double)w /pixsize_x*ratio,-3.1*(double)h /pixsize_y,3.1*(double)h /pixsize_y,  1.1 ,6.0+10);
    glOrtho(-size_ortho*ratio,size_ortho*ratio,-size_ortho,size_ortho,  nearlimit ,farlimit);
		
  }	
  perspec_radio = perspec; // ラジオボタンの値も変える
  /* モデルビュー変換行列の指定 */
  glMatrixMode(GL_MODELVIEW);
	
  // アイコンは正方形を仮定
  for (int i = 0;i < int_button;i++){
    icon_posi_x_window[i][0] = (icon_posi_x[i]+2.0*ratio)*0.25*h ; // アイコンのウインドウx座標
    icon_posi_y_window[i][0] = (-icon_posi_y[i]+2.0)*0.25*h  ; // アイコンのウインドウy座標
    icon_posi_x_window[i][1] = (icon_posi_x[i]+icon_scale[i]+2.0*ratio)*0.25*h ; // アイコンのウインドウx座標
    icon_posi_y_window[i][1] = (-icon_posi_y[i]+icon_scale[i]+2.0)*0.25*h  ; // アイコンのウインドウy座標
  }
  //  cout <<  (icon_posi_y_window[0]) << " " <<  (icon_posi_y_window[1]) << '\n'; 
  //  cout <<  icon_posi_y << " " <<  icon_posi_y+icon_scale << '\n'; 
	
}


void idle(int value) 
{
  glutPostRedisplay();
}

//glutSpecialFuncに対応
void spkeyboard(int key, int x, int y)
{
  double dx,dy,a;
  dx =0.0;
  dy = 0.0;
  switch (key) {
  case  GLUT_KEY_UP:	
    dy = sy*key_kaiten;
    break;
  case  GLUT_KEY_DOWN:	
    dy = -sy*key_kaiten;
    break;
  case  GLUT_KEY_RIGHT:	
    dx = -sx*key_kaiten;
    break;
  case  GLUT_KEY_LEFT:	
    dx = +sx*key_kaiten;
    break;
    // 以下斜め移動		
  case GLUT_KEY_F1: //右上
    dx= -sqrt(key_kaiten)*sx;	
    dy= sqrt(key_kaiten)*sy;				
    break;
  case GLUT_KEY_F2: //右下
    dx= -sqrt(key_kaiten)*sx;	
    dy= -sqrt(key_kaiten)*sy;
    break;		
  case GLUT_KEY_F3: //左上
    dx= sqrt(key_kaiten)*sx;	
    dy= sqrt(key_kaiten)*sy;
    break;
  case GLUT_KEY_F4: //左下
    dx= sqrt(key_kaiten)*sx;	
    dy= -sqrt(key_kaiten)*sy;		
    break;		
  default: break;
  }
  /* 回転の保存 */
  // if ( (rotsynch == 1)) 
  // if ( (glutGetWindow() == window1)){
  cq[0] = tq[0];
  cq[1] = tq[1];
  cq[2] = tq[2];
  cq[3] = tq[3];
    // }else {
  cq2[0] = tq2[0];
  cq2[1] = tq2[1];
  cq2[2] = tq2[2];
  cq2[3] = tq2[3];
    // }
	
  // 画像の回転	
  /* 移動距離 */
  a = sqrt(dx * dx + dy * dy);
	
  if (a != 0.0) {
    /* 回転のクォータニオン dq を求める */
    double ar = a * SCALE * 0.5;
    double as = sin(ar) / a;
    // パソコン画面のxy座標系とワールド座標系は別なことに注意！！
    double dq[4] = { cos(ar), dy * as, dx * as, 0.0 };
		
    /* 回転の初期値 cq に dq を掛けて回転を合成 */
    
    //
   
 
    
    //
    if (rotsynch == 1) {
      if  (glutGetWindow() == window1) {
	qmul(tq, dq, cq);
	qmul(tq2, qzure, tq);
	cq[0] = tq[0];
	cq[1] = tq[1];
	cq[2] = tq[2];
	cq[3] = tq[3];
	cq2[0] = tq2[0];
	cq2[1] = tq2[1];
	cq2[2] = tq2[2];
	cq2[3] = tq2[3];	
	  /* クォータニオンから回転の変換行列を求める */
	qrot(rt, tq);
	qrot(rt2, tq2);
      } else {
	qmul(tq2, dq, cq2);
	qmul(tq, qzure_inv, tq2);
	    
	    
	cq[0] = tq[0];
	cq[1] = tq[1];
	cq[2] = tq[2];
	cq[3] = tq[3];
	cq2[0] = tq2[0];
	cq2[1] = tq2[1];
	cq2[2] = tq2[2];
	cq2[3] = tq2[3];	
	    
      /* クォータニオンから回転の変換行列を求める */
	qrot(rt, tq);
	qrot(rt2, tq2);
      }

    } else if ( (glutGetWindow() == window1) ){
      qmul(tq, dq, cq);
    /* クォータニオンから回転の変換行列を求める */
      qrot(rt, tq);
    }else{
      qmul(tq2, dq, cq2);
      /* クォータニオンから回転の変換行列を求める */
      qrot(rt2, tq2);
    }
    int i;
    for (i = 0;i<16;i++) {
      rtglui[i] = rt[i];	 //glui用の回転
    }
		
    glutPostRedisplay();  /* 再描画 */
    return;
  }
}

void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
    //	case '\033':  /* '\033' は ESC の ASCII コード */
    exit(0);
  default:
    break;
  }
  switch (key) {
  case 'a':
    ntime =ntime +1;
    if (ntime >= ntimemax) {
      ntime = ntimemax-1;
    }
			
    anim=0;
			
    init_glut_menu();	
    glutPostRedisplay();
 
    break;
  case 'A':
    ntime =ntime +10;
    if (ntime >= ntimemax) {
      ntime = ntimemax-1;
    }
			
    anim=0;
			
    init_glut_menu();	
    glutPostRedisplay();
 
    break;
  case 'b':
    if (ntime != 0) ntime =ntime  - 1 ;
			
    anim=0;
			
    glutPostRedisplay();
    break;
  case 'B':
    if (ntime != 0) ntime =ntime  - 10 ;
    if (ntime < 0) {
      ntime = 0;
    }		
    anim=0;
			
    glutPostRedisplay();
    break;
    // 逆再生
  case 'r': 
    if (anim != -1){
      anim=-1 ;
				
    }	else {
      anim=0;
    }
    init_glut_menu();	
    glutPostRedisplay();
    break;
    // 拡大
  case 'l':
    if ( (glutGetWindow() == window1) || (synch == 1)){
      scale_factor = scale_factor*1.015;
      if (scale_factor > ez - nearlimit) scale_factor = ez - nearlimit; //　地球の内部が見えないように
    } else {
      scale_factor2 = scale_factor2*1.015;
      if (scale_factor2 > ez - nearlimit) scale_factor2 = ez - nearlimit; //　地球の内部が見えないように
    }
    glutPostRedisplay();
    break;
  case 'L':
    if ( (glutGetWindow() == window1) || (synch == 1)){
      scale_factor = scale_factor*1.2;
      if (scale_factor > ez - nearlimit) scale_factor = ez - nearlimit; //　地球の内部が見えないように
    } else {
      scale_factor2 = scale_factor2*1.2;
      if (scale_factor2 > ez - nearlimit) scale_factor2 = ez - nearlimit; //　地球の内部が見えないように
    }
    glutPostRedisplay();
    break;
    //縮小
  case 'h':
    if ( (glutGetWindow() == window1) || (synch == 1)){
      scale_factor = scale_factor*0.985221674877;
    } else {
      scale_factor2 = scale_factor2*0.985221674877;
    }		
    //			if (scale_factor < 0.4) scale_factor = 0.4; //　地球が小さくなりすぎないように
    glutPostRedisplay();
    break;
  case 'H':
    if ( (glutGetWindow() == window1) || (synch == 1)){
      scale_factor = scale_factor*0.8333333333333;
    }else {
      scale_factor = scale_factor*0.8333333333333;
    }		
    //			if (scale_factor < 0.4) scale_factor = 0.4; //　地球が小さくなりすぎないように
    glutPostRedisplay();
    break;
    //自転
  case 's': 
    if (jitenornot == 0){
      jitenornot=1 ;
    }	else {
      jitenornot=0;
    }
    init_glut_menu();	
    glutPostRedisplay();
    break;
  //緯線、経線の表示
  case 'm': 
    if (isenkeisenornot == 0){
      isenkeisenornot=1 ;
    }	else {
      isenkeisenornot=0;
    }
    init_glut_menu();	
    glutPostRedisplay();
    break;

  case 'f': //全画面
    if (fullscreen== 0){
      fullscreen =1;
      glutFullScreen();
    }
    else {
      fullscreen= 0;
      glutReshapeWindow(pixsize_x, pixsize_y);
    
     
    }
    break;

  case '\033': //ESCキー　全画面解除　
    fullscreen= 0;
    glutReshapeWindow(pixsize_x, pixsize_y);
    init_glut_menu();
    glutPostRedisplay();
    break;
    // 初期条件に戻す
  case 'i':
    init_rotate();
    thetajiten = INITJITEN; //自転角
    scale_factor = init_scale_factor; //大きさ
    scale_factor2 = init_scale_factor2; //大きさ
    trans[0] = trans_x;
    trans[1] = trans_y;
    trans2[0] = trans_x2;
    trans2[1] = trans_y2;
    ntime =0;
    jikan1 =clock() ;
    glutPostRedisplay();
    break;
    // 地軸の向きを初期条件の向きに合わせる
			
    // 1枚目の画像に
  case 'I':
    ntime =0;
    jikan1 =clock() ;
    glutPostRedisplay();
    break;
    // 最後の画像に
  case 'J':
    ntime =ntimemax-1;
    jikan1 =clock() ;
    glutPostRedisplay();
    break;
    // 地軸の向きを初期条件の向きに合わせる
  case 'n':
    latitude_rotate();
    break;
			
    // テクスチャアニメ		
  case 0x20: // スペースキーのアスキーコード
    if (anim != 1){
      anim=1 ;
				
    }	else {
      anim=0;
    }
    init_glut_menu();	
    glutPostRedisplay();
			
    break;
    //テクスチャアニメの再生速度
  case 0x2b: // プラスキーのアスキーコード
    if (++animsokudo >= ANIMSOKUDOMAX+1) animsokudo = ANIMSOKUDOMAX;
    init_glut_menu();	
    break;
  case 0x2d: // マイナスキーのアスキーコード
    if (--animsokudo <= ANIMSOKUDOMIN-1) animsokudo = ANIMSOKUDOMIN;
    init_glut_menu();	
    break;
    //自転の速度
  case 0x3e: // >のアスキーコード
    if (++jitensokudo >= JITENSOKUDOMAX+1) jitensokudo = JITENSOKUDOMAX;
    init_glut_menu();	
    break;
  case 0x3c: // <のアスキーコード
    if (--jitensokudo <= JITENSOKUDOMIN-1 ) jitensokudo = JITENSOKUDOMIN;
    init_glut_menu();	
    break;
			
  default: break;
			
  }
#ifdef USE_GLUI
  if (guilevel == 1)	gluiUpdate();        // Update user interface to reflect these changes
#endif
}

void mouse(int button, int state, int x, int y)
{
	
  if (glutGetModifiers() & GLUT_ACTIVE_SHIFT) { 
    /* SHIFTキーあり */
    scaling = 1;  /* スケーリング変更中 */
		
  }
  else {  /* SHIFTキーなし */
    scaling = 0; 
		
  }
	
  if (glutGetModifiers() & GLUT_ACTIVE_ALT) { 
    /* ALTキーあり */
    parallel = 1;  /* 平行移動*/
		
  }
  else {  /* ALTキーなし */
    parallel = 0; 
		
  }
	
  switch (button) {
			
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
					
      //	cout << x<< "  " <<y << '\n'; 
      /* ドラッグ開始点を記録 */
      cx = x;
      cy = y;
      /* アニメーション開始 */
      //glutIdleFunc(idle);
      glutTimerFunc(0,idle,0);
			
      if (rotsynch == 1) {
	// 回転を止める
	arhozon = 0.0;
	arhozon2 = 0.0;
	dxhozon = 0.0;
	dyhozon = 0.0;
	ahozon =0.0;
	arhozon_2 = 0.0;
	arhozon2_2 = 0.0;
	dxhozon_2 = 0.0;
	dyhozon_2 = 0.0;
	ahozon_2 =0.0;	
      } else    if ( glutGetWindow() == window1){
	arhozon = 0.0;
	arhozon2 = 0.0;
	dxhozon = 0.0;
	dyhozon = 0.0;
	ahozon =0.0;
      } else {
	arhozon_2 = 0.0;
	arhozon2_2 = 0.0;
	dxhozon_2 = 0.0;
	dyhozon_2 = 0.0;
	ahozon_2 =0.0;			
      }		
      // 画面上のボタン
      for (int i = 0; i<int_button; i++) {

	if ( icon_onoff[i] ==1){
	  if (  ( x > icon_posi_x_window[i][0]) &&  ( x < icon_posi_x_window[i][1]) ) {
	    if (  ( y < icon_posi_y_window[i][1])  && ( y > icon_posi_y_window[i][0]) ) {
	      pushbutton[i]= 1;
	      pushwindow = glutGetWindow();
	    }
	  }		
	}
      }
     				
					
      break;
    case GLUT_UP:
      
      // マウスのボタンがあがったときにボタンの効果が出る
  
      for (int i = 0; i<int_button; i++) {
	if (pushbutton[i] == 1){
	  if ( icon_onoff[i] ==1){
	    if (  ( x > icon_posi_x_window[i][0]) &&  ( x < icon_posi_x_window[i][1]) ) {
	      if (  ( y < icon_posi_y_window[i][1])  && ( y > icon_posi_y_window[i][0]) ) {
		pushedbutton[i] = 1;
	
		effect_icon(i);
		pushbutton[i] == 0;
	
	      }
	    }
	  }
	}
      }
      for (int i = 0; i<int_button; i++) {
	pushbutton[i]  = 0;
      }
 
      /* アニメーション終了 */
      glutIdleFunc(0);
   
      if ( pushedbutton[9] == 0){ // n ボタンを押していたときは除外する
	if ( (glutGetWindow() == window1) || (rotsynch == 1)){
	  /* 回転の保存 */
	  cq[0] = tq[0];
	  cq[1] = tq[1];
	  cq[2] = tq[2];
	  cq[3] = tq[3];
	}else{
	  cq2[0] = tq2[0];
	  cq2[1] = tq2[1];
	  cq2[2] = tq2[2];
	  cq2[3] = tq2[3];
	}
	
      }
      	
      for (int i = 0 ; i<int_button; i++){
	pushedbutton[i] = 0;
      }			
      break;
    default:
      break;
    }
    break;

  default:
    break;
  }

#ifdef USE_GLUI
  if (guilevel == 1)	gluiUpdate();        // Update user interface to reflect these changes
#endif

}

void motion(int x, int y)
{
  static double dx, dy;
  double tempdx = 0.0,tempdy=0.0, a;  
  //画像の拡大縮小
  if (scaling) {  /* スケーリング変更中ならば */
		
    if ( (glutGetWindow() == window1) || (synch == 1)) {
      scale_factor = scale_factor
	* (1.0f + (((GLfloat) (cy - y))*(GLfloat)sy));
      cx = x;
      cy = y;
      if (scale_factor > ez - nearlimit) scale_factor = ez - nearlimit; //　地球の内部が見えないように
    } else {
      scale_factor2 = scale_factor2
	 * (1.0f + (((GLfloat) (cy - y))*(GLfloat)sy));
      cx = x;
      cy = y;
      if (scale_factor2 > ez - nearlimit) scale_factor2 = ez - nearlimit; //　地球の内部が見えないように
    }
    


    //		if (scale_factor < 0.4) scale_factor = 0.4; //　地球が小さくなりすぎないように
    glutPostRedisplay();  /* 再描画 */
    return;
  }
	
  else if (parallel) { //平行移動中ならば。
    /* マウスポインタの位置のドラッグ開始位置からの変位 */
    dx = (x - cx) * sx;
    dy = (y - cy) * sy;
  
    if ( (glutGetWindow() == window1) || (synch == 1)) {
      trans[0] =trans[0] +  (GLfloat)(dx* XYSCALE/scale_factor) ;
      trans[1] = trans[1] - (GLfloat)(dy* XYSCALE/scale_factor) ;
    }else{
      trans2[0] =trans2[0] +  (GLfloat)(dx* XYSCALE/scale_factor2) ;
      trans2[1] = trans2[1] - (GLfloat)(dy* XYSCALE/scale_factor2) ; 
    }
    cx = x;
    cy = y;
    glutPostRedisplay();  /* 再描画 */
    return;
  }
	
  else {
		
    // 画像の回転	
    /* マウスポインタの位置のドラッグ開始位置からの変位 */
		
		
    tempdx= dx;
    // dx = (x - cx) * sx;
    dx = (x - cx) * sy;
    tempdy= dy;
    dy = (y - cy) * sy;
    cx= x;
    cy= y;
		
    //		cout << dx <<'\n';
    {
      double ratio = sy/sx; 
      if (tempdx - dx > 0.7*ratio){
	dx = dx+1.0*ratio;
      }	else if (tempdx - dx < -0.7*ratio) {
	dx = dx-1.0*ratio;
      }
    }
		
    if (tempdy- dy > 0.7){
      dy = dy+1.0;
    }	else if (tempdy - dy < -0.7) {
      dy = dy-1.0;
    }
		
    /* マウスポインタの位置のドラッグ開始位置からの距離 */
    a = sqrt(dx * dx + dy * dy);
		
    if (a != 0.0) {
      /* マウスのドラッグに伴う回転のクォータニオン dq を求める */
      double ar ;
      if ( (glutGetWindow() == window1) || (synch == 1)){
	ar = a * SCALE * 0.5/scale_factor;
      } else {
	ar = a * SCALE * 0.5/scale_factor2;
      }
      double as = sin(ar) / a;
      // マウスのドラッグした座標系とワールド座標系は別なことに注意！！
      double dq[4] = { cos(ar), dy * as, dx * as, 0.0 };
			
      // arとdx,dy,を保存
      if ( glutGetWindow() == window1){

	arhozon = ar;
	arhozon2 = ar;
	dxhozon = dx;
	dyhozon = dy;
	ahozon = a;

      } else {
    
	arhozon_2 = ar;
	arhozon2_2 = ar;
	dxhozon_2 = dx;
	dyhozon_2 = dy;
	ahozon_2 = a;
      }
     

      if (rotsynch == 1) {
      /* 回転の初期値 cq に dq を掛けて回転を合成 */
	if ( (glutGetWindow() == window1) ){
	  qmul(tq, dq, cq);
	  qmul(tq2, qzure, tq);
	  cq[0] = tq[0];
	  cq[1] = tq[1];
	  cq[2] = tq[2];
	  cq[3] = tq[3];
	  cq2[0] = tq2[0];
	  cq2[1] = tq2[1];
	  cq2[2] = tq2[2];
	  cq2[3] = tq2[3];	
	  /* クォータニオンから回転の変換行列を求める */
	  qrot(rt, tq);
	  qrot(rt2, tq2);
	} else if ((glutGetWindow() == window2)) {
	    
	  qmul(tq2, dq, cq2);
	  qmul(tq, qzure_inv, tq2);
	    
	    
	  cq[0] = tq[0];
	  cq[1] = tq[1];
	  cq[2] = tq[2];
	  cq[3] = tq[3];
	  cq2[0] = tq2[0];
	  cq2[1] = tq2[1];
	  cq2[2] = tq2[2];
	  cq2[3] = tq2[3];	
	    
      /* クォータニオンから回転の変換行列を求める */
	  qrot(rt, tq);
	  qrot(rt2, tq2);
	    
	}
      }else {
 /* 回転の初期値 cq に dq を掛けて回転を合成 */
	if ( (glutGetWindow() == window1)){
	  qmul(tq, dq, cq);
	  cq[0] = tq[0];
	  cq[1] = tq[1];
	  cq[2] = tq[2];
	  cq[3] = tq[3];
	/* クォータニオンから回転の変換行列を求める */
	  qrot(rt, tq);
	}
	if ((glutGetWindow() == window2)) {
	  qmul(tq2, dq, cq2);
	  cq2[0] = tq2[0];
	  cq2[1] = tq2[1];
	  cq2[2] = tq2[2];
	  cq2[3] = tq2[3];
	/* クォータニオンから回転の変換行列を求める */
	  qrot(rt2, tq2);
	}
      }

    }
    
 
    
    for (int i = 0;i<16;i++) {
      rtglui[i] = rt[i];	 //glui用の回転
    }
    glutPostRedisplay();  /* 再描画 */
    return;
  }
}


/* Applicationメニュー関数 */
static void app_menu_func(int menu)
{
  switch (menu) {
  case APP_QUIT:
    exit(0);  /* APP_QUITメニューでプログラム終了 */
    break;
			
    // テクスチャアニメ
  case APP_ANIM:
    if (anim==1){
      anim=0;
    }	else {
      anim=1;
    }
    init_glut_menu();	
    glutPostRedisplay();
    break;		
    //逆再生
  case APP_R_ANIM:
    if (anim==-1){
      anim=0;
    }	else  {
      anim=-1;
    }
			
    init_glut_menu();	
    glutPostRedisplay();
    break;	
    // 自転
  case APP_JITEN:
    if (jitenornot==0){
      jitenornot=1;
    }	else  {
      jitenornot=0;
    }	
    init_glut_menu();	
    glutPostRedisplay();
    break;	
    // 自転
    /*
      case APP_INITTEXTURE:
      ntime =0;
      jikan1 =clock() ;
      glutPostRedisplay();
      break;	
      *?
      /*
      case APP_PRINT:
      if (print_dame ==0 ){
      if (print==1){
      print=0;
      }	else {
      print=1;
      }
      } else if (print_dame ==1) {
      glui2->show( );
      cout << "File Save Error." << '\n';
      }
      glutPostRedisplay();	
      break;
    */
			
  case APP_SCREEN: // スクリーンサイズ変更
    if (fullscreen== 0){
      fullscreen =1;
      glutFullScreen();
    }
    else {
      fullscreen= 0;
      glutReshapeWindow(pixsize_x, pixsize_y);
    }
    init_glut_menu();
    glutPostRedisplay();
    break;
  case APP_PERSPEC:
    if (perspec==1){
      perspec=0;
    }	else {
      perspec=1;
    }
    int hoge;
    hoge = glutGetWindow();
    glutSetWindow(window1);
    resize(1.0/sx, 1.0/sy);
    init_glut_menu();	
    glutPostRedisplay();
    glutSetWindow(window2);
    resize(1.0/sx, 1.0/sy);
    init_glut_menu();	
    glutPostRedisplay();
    glutSetWindow(hoge);
    break;
  case APP_START:
    /* 回転の初期値 (クォータニオン) */
    init_rotate();
    thetajiten = INITJITEN; //自転角
    scale_factor = init_scale_factor; //大きさ
    scale_factor2 = init_scale_factor2; //大きさ
    trans[0] =  trans_x;
    trans[1] =	 trans_y;
    trans2[0] =  trans_x2;
    trans2[1] =	 trans_y2;
    ntime =0;
    jikan1 =clock() ;
    glutPostRedisplay();
			
    break;
  case APP_FOG:
    if (fogornot==1){
      fogornot=0;
    }	else {
      fogornot=1;
    }
    fog();
			
    glutPostRedisplay();
			
    break;
			
  default:
    break;
  }
#ifdef USE_GLUI
  if (guilevel == 1)	gluiUpdate();        // Update user interface to reflect these changes
#endif
}

/* GLUTメニューコールバック関数 */
static void menu_func(int dummy0)
{
  /* 何もしない */
  return;
}

/* GLUTメニューの初期化 */
void init_glut_menu(void)
{
#ifndef WINDOWS
  int app_menu;
  /* Applicationメニューを登録 */
  // 再生
  app_menu = glutCreateMenu(app_menu_func);
  if (anim != 1 ){
    glutAddMenuEntry("Play(space)", APP_ANIM);
  } else if (anim ==1){
    glutAddMenuEntry("Stop play(space)", APP_ANIM);
  }
    
  // 逆再生
  if (anim != -1 ){
    glutAddMenuEntry("Reverse(r)", APP_R_ANIM);
  } else if (anim ==-1) {
    glutAddMenuEntry("Stop reverse(r)", APP_R_ANIM);
  }	
	
  // 自転
  if (jitenornot == 0 ){
    glutAddMenuEntry("Spin(s)", APP_JITEN);
  } else if (jitenornot ==1) {
    glutAddMenuEntry("Stop spin(s)", APP_JITEN);
  }
    
  if (perspec ==1 ){
    glutAddMenuEntry("Orthogonal", APP_PERSPEC);
  } else {
    glutAddMenuEntry("Perspective", APP_PERSPEC);
  }
  if (fullscreen ==1 ){
    glutAddMenuEntry("Default screen size", APP_SCREEN);
  } else {
    glutAddMenuEntry("Full screen", APP_SCREEN);
  }
  /*
    if (fogornot ==1 ){
    glutAddMenuEntry("Remove fog", APP_FOG);
    } else {
    glutAddMenuEntry("Fog", APP_FOG);
    }
  */
	
	
  //	glutAddMenuEntry("Initialization of time(i)", APP_INITTEXTURE);
  glutAddMenuEntry("Initialization (i)", APP_START);
	
	
  //			glutAddMenuEntry("Output image", APP_PRINT);
	
	
  glutAddMenuEntry("Quit(q)", APP_QUIT);
	
  /* メニューを登録 */
  glutCreateMenu(menu_func);
	
  /*------ for iPad 2010-06-19 by Saito-A ------*/
  if( ipad_frag ==1) {
    glutAddMenuEntry("Click", -1);
    glutAddMenuEntry("   Top-Left corner:		Full screen", -1);
    glutAddMenuEntry("   Bottom-Left corner:	Animation", -1);
    glutAddMenuEntry("   Bottom-Right corner:	Initial view", -1);
    glutAddMenuEntry("", -1);
  }
  /*-------------------------------------------------*/				 
	
  glutAddSubMenu("Applications", app_menu);
  glutAddMenuEntry("Scaling(Shift+mouse) ",-1 );
  glutAddMenuEntry("Parallel displacement(Alt+mouse) ",-1 );
  // プレイスピード
  char str0[32];
  char str1[]="Play speed ";
  char str2[] = "; fast(+), slow(-)";
  sprintf(str0,"%s%d%s", str1,animsokudo,str2); 
  glutAddMenuEntry(str0,-1 );
  // 自転スピード
  char str3[] = "Spin speed ";
  char str4[] = "; fast(>), slow(<)";
  sprintf(str0,"%s%d%s", str3,jitensokudo,str4); 
  glutAddMenuEntry(str0,-1 );
  /* メニューをマウス右ボタンにアタッチ */
  glutAttachMenu(GLUT_RIGHT_BUTTON);
#endif
}

void latitude_rotate(void)
{
  double phi1;
  if (rotsynch == 1) {
    
    if  (glutGetWindow() == window1) {
      double direction[3] = { rt[8],rt[9],rt[10]} ;// 今の地軸の向き
    // cout << direction[0] << " " <<  direction[1] << " " <<  direction[2] << '\n';
    // directionと  (0,1,0)との内積はrt[9]
      double tmp = sqrt(rt[8]*rt[8]+rt[9]*rt[9]);
      if (tmp < 0.0000000000001) {
	phi1 = 0.0;
      } else {
	phi1 = acos(rt[9]/tmp);
      }
      if (rt[8] < 0 ) phi1 = -phi1; 
      /* 回転行列の初期化 */
      double cqtmp[4] = {cq[0],cq[1],cq[2],cq[3]};
      double quat1[4] = {cos(phi1*0.5),0.0,0.0,sin(phi1*0.5)};
    /* 回転を合成 */
	
      qmul(cq, quat1,cqtmp);
      qmul(cq2, qzure, cq);
  /* クォータニオンから回転の変換行列を求める */
      qrot(rt, cq);
      qrot(rt2, cq2);
      for (int i = 0;i<16;i++) {
	rtglui[i] = rt[i];  //glui用の回転
      }
    
      glutPostRedisplay();  /* 再描画 */
      return;

    } else {
      double direction[3] = { rt2[8],rt2[9],rt2[10]} ;// 今の地軸の向き
    // cout << direction[0] << " " <<  direction[1] << " " <<  direction[2] << '\n';
    // directionと  (0,1,0)との内積はrt[9]
      double tmp = sqrt(rt2[8]*rt2[8]+rt2[9]*rt2[9]);
      if (tmp < 0.0000000000001) {
	phi1 = 0.0;
      } else {
	phi1 = acos(rt2[9]/tmp);
      }
      if (rt2[8] < 0 ) phi1 = -phi1; 
      /* 回転行列の初期化 */
      double cqtmp[4] = {cq2[0],cq2[1],cq2[2],cq2[3]};
      double quat1[4] = {cos(phi1*0.5),0.0,0.0,sin(phi1*0.5)};
    /* 回転を合成 */
	
      qmul(cq2, quat1,cqtmp);
      qmul(cq, qzure_inv, cq2);
  /* クォータニオンから回転の変換行列を求める */
      qrot(rt, cq);
      qrot(rt2, cq2);
      for (int i = 0;i<16;i++) {
	rtglui[i] = rt[i];  //glui用の回転
      }
    
      glutPostRedisplay();  /* 再描画 */
      return;
    }
  } else if ( (glutGetWindow() == window1)){	
    double direction[3] = { rt[8],rt[9],rt[10]} ;// 今の地軸の向き
    // cout << direction[0] << " " <<  direction[1] << " " <<  direction[2] << '\n';
    // directionと  (0,1,0)との内積はrt[9]
    double tmp = sqrt(rt[8]*rt[8]+rt[9]*rt[9]);
    if (tmp < 0.0000000000001) {
      phi1 = 0.0;
    } else {
      phi1 = acos(rt[9]/tmp);
    }
    if (rt[8] < 0 ) phi1 = -phi1; 
    /* 回転行列の初期化 */
    double cqtmp[4] = {cq[0],cq[1],cq[2],cq[3]};
    double quat1[4] = {cos(phi1*0.5),0.0,0.0,sin(phi1*0.5)};
    /* 回転を合成 */
	
	
    qmul(cq, quat1,cqtmp);
    
  /* クォータニオンから回転の変換行列を求める */
    qrot(rt, cq);
    for (int i = 0;i<16;i++) {
      rtglui[i] = rt[i];  //glui用の回転
    }
    
    glutPostRedisplay();  /* 再描画 */
    return;
  }else {
    double direction[3] = { rt2[8],rt2[9],rt2[10]} ;// 今の地軸の向き
    // cout << direction[0] << " " <<  direction[1] << " " <<  direction[2] << '\n';
    // directionと  (0,1,0)との内積はrt[9]
    double tmp = sqrt(rt2[8]*rt2[8]+rt2[9]*rt2[9]);
    if (tmp < 0.0000000000001) {
      phi1 = 0.0;
    } else {
      phi1 = acos(rt2[9]/tmp);
    }
    if (rt2[8] < 0 ) phi1 = -phi1; 
    /* 回転行列の初期化 */
    double cqtmp[4] = {cq2[0],cq2[1],cq2[2],cq2[3]};
    double quat1[4] = {cos(phi1*0.5),0.0,0.0,sin(phi1*0.5)};
    /* 回転を合成 */
	
	
    qmul(cq2, quat1,cqtmp);
    
  /* クォータニオンから回転の変換行列を求める */
    qrot(rt2, cq2);
    for (int i = 0;i<16;i++) {
      rtglui[i] = rt[i];  //glui用の回転
    }
    
    glutPostRedisplay();  /* 再描画 */
    return;
  }
}

void init_rotate(void)
{
  //初期値のままでは、上から眺めた絵になる
  double quat1[4];
  double quat2[4];
	
	
  theta2 =- 3.1415926/2.0  - rad_longitude;//経度 （imageの左端が経度-180）
  theta1 = - rad_latitude; // 緯度（北極がゼロ度）
  theta2_2 =- 3.1415926/2.0  - rad_longitude2;//経度 （imageの左端が経度-180）
  theta1_2 = - rad_latitude2; // 緯度（北極がゼロ度）
  double r2[3] = {0.0,0.0,1.0};
  //	double r1[3] = {cos(rad_longitude),sin(rad_longitude),0.0};
  double r1[3] = {1.0,0.0,0.0};
	
	
  /* 回転行列の初期化 */
  quat1[0] = cos(theta1*0.5);
  quat1[1] = r1[0]*sin(theta1*0.5);
  quat1[2] = r1[1]*sin(theta1*0.5);
  quat1[3] = r1[2]*sin(theta1*0.5);
	
  quat2[0] = cos(theta2*0.5);
  quat2[1] = r2[0]*sin(theta2*0.5) ;
  quat2[2] = r2[1]*sin(theta2*0.5) ;
  quat2[3] = r2[2]*sin(theta2*0.5) ;
	
  /* 回転を合成 */
  qmul(cq, quat1, quat2);
  tq[0] = cq[0];
  tq[1] = cq[1];
  tq[2] = cq[2];
  tq[3] = cq[3];
  /* クォータニオンから回転の変換行列を求める */
  qrot(rt, cq);

  if ( (rotsynch == 0) && (nsphere == 2)) {
	
  /* 回転行列の初期化 */
    quat1[0] = cos(theta1_2*0.5);
    quat1[1] = r1[0]*sin(theta1_2*0.5);
    quat1[2] = r1[1]*sin(theta1_2*0.5);
    quat1[3] = r1[2]*sin(theta1_2*0.5);
    
    quat2[0] = cos(theta2_2*0.5);
    quat2[1] = r2[0]*sin(theta2_2*0.5) ;
    quat2[2] = r2[1]*sin(theta2_2*0.5) ;
    quat2[3] = r2[2]*sin(theta2_2*0.5) ;
	
  /* 回転を合成 */
    qmul(cq2, quat1, quat2);
    tq2[0] = cq2[0];
    tq2[1] = cq2[1];
    tq2[2] = cq2[2];
    tq2[3] = cq2[3];
  /* クォータニオンから回転の変換行列を求める */
    qrot(rt2, cq2);

  }
  if (rotsynch ==1){
    qmul(tq2, qzure, tq);
    cq2[0] = tq2[0];
    cq2[1] = tq2[1];
    cq2[2] = tq2[2];
    cq2[3] = tq2[3];	
    /* クォータニオンから回転の変換行列を求める */
   
    qrot(rt2, tq2);
  }
  int i;
  for (i = 0;i<16;i++) {
    rtglui[i] = rt[i];	 //glui用の回転
  }
}

void fog(void)
{
  // FOG処理
  if (fogornot == 1) {
		
    glEnable(GL_FOG);
    {
      GLfloat fogColor[4] = {0.15f,0.15f,0.15f,1.0f};
      fogMode = GL_EXP2;
      glFogi(GL_FOG_MODE, fogMode);
      glFogfv(GL_FOG_COLOR, fogColor);
      glFogf(GL_FOG_DENSITY, 0.3);	
      glHint(GL_FOG_HINT, GL_DONT_CARE);
      glFogf(GL_FOG_START,0.5);
      glFogf(GL_FOG_END, 8.0);
    }	
		
  }
  else{		
    GLfloat fogColor[4] = {0.15f,0.15f,0.15f,1.0f};
    fogMode = GL_EXP2;
    glFogi(GL_FOG_MODE, fogMode);
    glFogfv(GL_FOG_COLOR, fogColor);
    glFogf(GL_FOG_DENSITY, 0.00);	
    glHint(GL_FOG_HINT, GL_DONT_CARE);
    glFogf(GL_FOG_START,0.5);
    glFogf(GL_FOG_END, 8.0);	
  }
}

void init(int num_window)
{
	
  /* 初期設定 */
  glClearColor(0.0, 0.0, 0.0, 0.0);
  // タイトル 
  if (num_window == window2) {
    glutSetWindowTitle("CKK 1.13(2)");
  }
  else {
    glutSetWindowTitle("CKK 1.13");   
  }

	
  glEnable(GL_CULL_FACE); // ポリゴンのウラ面を表示しない
	
  /*
  ** 光源
  */
	
  //		static const GLfloat lightpos[] = { 0.0f, 0.0f, 1.0f, 0.0f }; /* 位置　　　 */
  //		static const GLfloat lightcol[] = { 1.0f, 1.0f, 1.0f, 1.0f }; /* 直接光強度 */
  //		static const GLfloat lightamb[] = { 0.1f, 0.1f, 0.1f, 1.0f }; /* 環境光強度 */
	
  //		glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  //		glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  //		glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
	
  /* 光源の位置を設定 */
  //		glLightfv(GL_LIGHT0, GL_POSITION, pos);
	
  //		glEnable(GL_LIGHTING);
  //		glEnable(GL_LIGHT0);
	
  //		fog();
	
  init_glut_menu();  /* メニューを初期化 */
	
  init_rotate(); //回転の初期化
	
  jikan1 = clock();
  jikan2= clock(); 	
	
  // ディスプレイリストを登録
  listSphere = glGenLists(1);
  glNewList(listSphere, GL_COMPILE);
  sphere(1.0); 
  glEndList();
	
  //perspective用のfovyの計算
  fovy = 2.0*atan(size_ortho/ez )/3.1415926*180.0; // gluOrthoと同じ大きさ(z = 0の面で)
  farlimit =ez +20.0;	
}


/* 画像ファイルの読み込み（ppm形式） */
char *load_image(FILE *fin, int *resox, int *resoy)
{
  char *image;
  int youryou,n_x,n_y;
  char buff[255];
  //char head;
  /* ヘッダの読み飛ばし */
  fgets(buff, 255, fin);
  /* コメントの読み飛ばし */
  do {
    fgets(buff, 255, fin);
  }
  while (buff[0] == '#');
	
  /*改行の読み飛ばし*/
  if  (buff[0] == '\n') fgets(buff, 255, fin);
	
  /* 画像サイズの読み出し */
	
  sscanf(buff, "%d %d", &n_x, &n_y);
  youryou = (n_x) *(n_y) * 3;
  *resox= n_x;
  *resoy =n_y;
  /* カラー深度読み飛ばし */
  fgets(buff, 255, fin);
  /* 画像読み出し */
  image = (char *)calloc(youryou, sizeof(GLubyte));
  fread(image, sizeof(char), youryou, fin);
  return image;
}


/* 画像ファイルの読み込み（ppm形式、黒は透明に） */
char *load_image_toumei(FILE *fin, int *resox, int *resoy)
{
  char *image;
  int youryou,n_x,n_y;
  char buff[255];
  //char head;
  /* ヘッダの読み飛ばし */
  fgets(buff, 255, fin);
  /* コメントの読み飛ばし */
  do {
    fgets(buff, 255, fin);
  }
  while (buff[0] == '#');
	
  /*改行の読み飛ばし*/
  if  (buff[0] == '\n') fgets(buff, 255, fin);
	
  /* 画像サイズの読み出し */
	
  sscanf(buff, "%d %d", &n_x, &n_y);
  youryou = (n_x) *(n_y) * 3;
  *resox= n_x;
  *resoy =n_y;
  /* カラー深度読み飛ばし */
  fgets(buff, 255, fin);
  /* 画像読み出し */
  image = (char *)calloc(youryou, sizeof(GLubyte));
  fread(image, sizeof(char), youryou, fin);
  char* image2;
  image2 = (char *)calloc((n_x) *(n_y) * 4, sizeof(GLubyte));
  for (int i = 0;i<n_x*n_y;++i){
    image2[i*4+0] = image[i*3+0];
    image2[i*4+1] = image[i*3+1];
    image2[i*4+2] = image[i*3+2];
 
    if ( (int)image[i*3+0] + (int)image[i*3+1] +  (int)image[i*3+2] ==0){
      image2[i*4+3] = (GLubyte)0;
    }else{
      image2[i*4+3] = (GLubyte)255;
    }
   }
  return image2;
}



/* 画像ファイルの読み込み（ppm形式、ボタンを押したときのテクスチャ） */
char *load_image_pushed(FILE *fin, int *resox, int *resoy)
{
  char *image;
  int youryou,n_x,n_y;
  char buff[255];
  //char head;
  /* ヘッダの読み飛ばし */
  fgets(buff, 255, fin);
  /* コメントの読み飛ばし */
  do {
    fgets(buff, 255, fin);
  }
  while (buff[0] == '#');
	
  /*改行の読み飛ばし*/
  if  (buff[0] == '\n') fgets(buff, 255, fin);
	
  /* 画像サイズの読み出し */
	
  sscanf(buff, "%d %d", &n_x, &n_y);
  youryou = (n_x) *(n_y) * 3;
  *resox= n_x;
  *resoy =n_y;
  /* カラー深度読み飛ばし */
  fgets(buff, 255, fin);
  /* 画像読み出し */
  image = (char *)calloc(youryou, sizeof(GLubyte));
  fread(image, sizeof(char), youryou, fin);
  char* image2;
  image2 = (char *)calloc((n_x) *(n_y) * 4, sizeof(GLubyte));

 
  for (int i = 0;i<n_x*n_y;++i){
  
    
    if ( (int)image[i*3+0]* (int)image[i*3+1]*  (int)image[i*3+2] ==0){
      image2[i*4+0] = (GLubyte)0;
      image2[i*4+1] = (GLubyte)0;
      image2[i*4+2] = (GLubyte)0;
      image2[i*4+3] = (GLubyte)0;
    } else {
      image2[i*4+0] = (GLubyte) 10;
      image2[i*4+1] = (GLubyte) 10;
      image2[i*4+2] = (GLubyte) 10;
      image2[i*4+3] =  (GLubyte) 130;
    }
   }

  return image2;
}

// テクスチャを読み込むルーチン
void fileyomitori (int num_window)
{
	
#ifdef USE_CV
  cvtexture (); //opencvを使って読み込む
#else
  //	
	
	
  // ppmファイルを読み取る
	
  // アイコン
  FILE* icon_f;

  if (int_button > 0 ){
    icon_f = fopen("data/icons/play.ppm", "rb");
  
    if ( icon_f!=NULL){
      pushed_icon.imageData = load_image_pushed(icon_f,&pushed_icon.width,&pushed_icon.height);
      fclose(icon_f);
    }
  
  }

  
  if ( icon_onoff[0] ==1 ){
    icon_f = fopen("data/icons/play.ppm", "rb");

    if ( icon_f!=NULL){
         icon[0].imageData = load_image_toumei(icon_f,&icon[0].width,&icon[0].height);
	 
      fclose(icon_f);
    } else {
      int_button  = 0;
    }
  }
		
  if (		(icon_onoff[0] ==1) || (icon_onoff[2] ==1 )){
    icon_f = fopen("data/icons/pause.ppm", "rb");
		
    if ( icon_f!=NULL){
      icon[1].imageData = load_image_toumei(icon_f,&icon[1].width,&icon[1].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    }
  }
		
  if (		icon_onoff[1] ==1 ){
    icon_f = fopen("data/icons/initial.ppm", "rb");
    if ( icon_f!=NULL){
      icon[2].imageData = load_image_toumei(icon_f,&icon[2].width,&icon[2].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }
		
  if (		icon_onoff[2] ==1 ){
    icon_f = fopen("data/icons/r_play.ppm", "rb");
    if ( icon_f!=NULL){
      icon[3].imageData = load_image_toumei(icon_f,&icon[3].width,&icon[3].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }
		
  if (		icon_onoff[3] ==1 ){
    icon_f = fopen("data/icons/spin.ppm", "rb");
    if ( icon_f!=NULL){
      icon[4].imageData = load_image_toumei(icon_f,&icon[4].width,&icon[4].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
		
    icon_f = fopen("data/icons/stop_spin.ppm", "rb");
    if ( icon_f!=NULL){
      icon[5].imageData = load_image_toumei(icon_f,&icon[5].width,&icon[5].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
				
  }
		
  if (		icon_onoff[4] ==1 ){
    icon_f = fopen("data/icons/forward.ppm", "rb");
    if ( icon_f!=NULL){
      icon[6].imageData = load_image_toumei(icon_f,&icon[6].width,&icon[6].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }
		
  if (		icon_onoff[5] ==1 ){
    icon_f = fopen("data/icons/back.ppm", "rb");
    if ( icon_f!=NULL){
      icon[7].imageData = load_image_toumei(icon_f,&icon[7].width,&icon[7].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }

  if (		icon_onoff[6] ==1 ){
    icon_f = fopen("data/icons/line.ppm", "rb");
    if ( icon_f!=NULL){
      icon[8].imageData = load_image_toumei(icon_f,&icon[8].width,&icon[8].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
    icon_f = fopen("data/icons/delete_line.ppm", "rb");
    if ( icon_f!=NULL){
      icon[9].imageData = load_image_toumei(icon_f,&icon[9].width,&icon[9].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 

  }

  if (		icon_onoff[7] ==1 ){
    icon_f = fopen("data/icons/zoomin.ppm", "rb");
    if ( icon_f!=NULL){
      icon[10].imageData = load_image_toumei(icon_f,&icon[10].width,&icon[10].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }	
  if (		icon_onoff[8] ==1 ){
    icon_f = fopen("data/icons/zoomout.ppm", "rb");
    if ( icon_f!=NULL){
      icon[11].imageData = load_image_toumei(icon_f,&icon[11].width,&icon[11].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }	

  if ( icon_onoff[9] ==1 ){
    icon_f = fopen("data/icons/north.ppm", "rb");
    if ( icon_f!=NULL){
      icon[12].imageData = load_image_toumei(icon_f,&icon[12].width,&icon[12].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }

  if ( icon_onoff[10] ==1 ){
    icon_f = fopen("data/icons/fast.ppm", "rb");
    if ( icon_f!=NULL){
      icon[13].imageData = load_image_toumei(icon_f,&icon[13].width,&icon[13].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }	

  if ( icon_onoff[11] ==1 ){
    icon_f = fopen("data/icons/slow.ppm", "rb");
    if ( icon_f!=NULL){
      icon[14].imageData = load_image_toumei(icon_f,&icon[14].width,&icon[14].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }	

  
  if ( icon_onoff[12] ==1 ){
    icon_f = fopen("data/icons/quit.ppm", "rb");
    if ( icon_f!=NULL){
     icon[15].imageData = load_image_toumei(icon_f,&icon[15].width,&icon[15].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
  }		

  if ( icon_onoff[13] ==1 ){
    icon_f = fopen("data/icons/normalscreen.ppm", "rb");
    if ( icon_f!=NULL){
      icon[16].imageData = load_image_toumei(icon_f,&icon[16].width,&icon[16].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 
    icon_f = fopen("data/icons/fullscreen.ppm", "rb");
    if ( icon_f!=NULL){
      icon[17].imageData = load_image_toumei(icon_f,&icon[17].width,&icon[17].height);
      fclose(icon_f);
    } else {
      int_button  = 0;
    } 



  }
  
 
  int n;
  int   nmaxtexture ;
  int istart = 0;
  // 二つ目の惑星のテクスチャが異なる場合
  if (second_sphere_texture == 1){

    if (num_window == window2) {
      nmaxtexture = 2*ntimemax;
      istart = ntimemax;
    }else{
      nmaxtexture = ntimemax;
    }
    
  }
  else{
    if (num_window == window2) {
      nmaxtexture = istart; // window2は読み込まない
    }
    else {
      nmaxtexture = ntimemax;
    }
  }
 
  for (int i =istart ; i < nmaxtexture;i++){	
    FILE* gazou_f;  
    FILE* logogazou_f;
    char temp[10];
    string str_suffix_tex;
    string str_suffix_screen;
    string strtexname ;
    string strscreenname; 
    if (i >= ntimemax) {
      
      n = i+tex_start -ntimemax;
      sprintf(temp,"%d",n) ;
      string temp2 = string(temp);
      strtexname = strtexfile2 +temp2+ "." +strtexfile_s2;
      strscreenname = strscreenfile2 +temp2+ "." +strscreenfile_s2;
      str_suffix_tex = strtexfile_s2;
      str_suffix_screen = strscreenfile_s2;
     
      
    } else{
    
      n = i+tex_start;
      sprintf(temp,"%d",n) ;
      string temp2 = string(temp);
      strtexname = strtexfile +temp2+ "." +strtexfile_s;
      strscreenname = strscreenfile +temp2+ "." +strscreenfile_s;
      str_suffix_tex = strtexfile_s;
      str_suffix_screen = strscreenfile_s;
     
    }
   
		
    gazou_f = fopen(strtexname.c_str(), "rb");
		
  
    if( gazou_f == NULL ){ // 地球の画像がない場合
      

	ntimemax=i;


      if (ntimemax ==0 ) 
	{
	  printf("%s\n","No sphere texture file");
	}
      break; // ループを抜ける
    }
   
    //  if (num_window == window1) {
    //   gazou_f = fopen(strtexname.c_str(), "rb");
    // } else {
    //   gazou_f = fopen(string("map2/map_0.ppm").c_str(), "rb");
    // }

    if( "jpg" == str_suffix_tex || "jpeg" == str_suffix_tex ){
      image1[i].imageData =   load_image_jpeg(gazou_f,&image1[i].width,&image1[i].height);
    }
    else{
      image1[i].imageData =   load_image(gazou_f,&image1[i].width,&image1[i].height);
    }		
    fclose(gazou_f);
		
    // ロゴ読み取りcv
    logogazou_f = fopen(strscreenname.c_str(), "rb");			
    if( logogazou_f != NULL ){
      if( "jpg" == str_suffix_screen || "jpeg" == str_suffix_screen ){
	if (screen_front ==1 ){
	  image2[i].imageData =	load_image_jpeg_toumei(logogazou_f,&image2[i].width,&image2[i].height);
	} else {
	  image2[i].imageData =	load_image_jpeg(logogazou_f,&image2[i].width,&image2[i].height);
	}

      }
      else{
	if (screen_front ==1 ){
	  image2[i].imageData =	load_image_toumei(logogazou_f,&image2[i].width,&image2[i].height);
	} else {
	  image2[i].imageData =	load_image(logogazou_f,&image2[i].width,&image2[i].height);
	}
      }
      mask_logo[i] = 1;
      fclose(logogazou_f);

     

    } 
    else {	// ロゴの画像がない場合
      mask_logo[i] = 0;
    }
		
  }
  if (ntime > ntimemax-1) ntime = ntimemax-1;
	
  // ファイルを読み取る（ここまで）
#endif
	
	
	
	
#ifdef USE_GLUI
  if (guilevel == 1) gluiSetscrollbar(0,ntimemax-1); //　スクロールバーの最大値を変化させる
#endif
	
  // オブジェクトリストの名前の生成
  glGenTextures(2,texName);
	
	
  // 地球テクスチャの設定
 
  glBindTexture(GL_TEXTURE_2D,texName[0]);
	
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    //GL_NEARESTは近くの値を採用する。GL_NEARESTは双線形補完
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); 
  // glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);		
  /* テクスチャの繰り返し方法の指定 */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP); 
  glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL); //下地の色とブレンドしない
	
  //		glTexImage2D(GL_TEXTURE_2D, 0,GL_RGB, imagecv1[ntime]->width,imagecv1[ntime]->height, 0,GL_RGB,GL_UNSIGNED_BYTE,imagecv1[ntime]->imageData);
  glTexImage2D(GL_TEXTURE_2D, 0,GL_RGB, image1[ntime].width,image1[ntime].height, 0,GL_RGB,GL_UNSIGNED_BYTE,image1[ntime].imageData);
 
   
 

	
  // ロゴテクスチャの設定	
  glBindTexture(GL_TEXTURE_2D,texName[1]);
	
  if (screen_front == 1){
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  } else{
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  }

  //GL_NEARESTは近くの値を採用する。GL_NEARESTは双線形補完
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); 
  // glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);		
  /* テクスチャの繰り返し方法の指定 */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
 if (screen_front == 1){
      glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE); //下地の色とブレンド
  } else{
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL); //下地の色とブレンドしない
  }
 
 if ( screen_front == 1 ){
   glTexImage2D(GL_TEXTURE_2D,0, GL_RGBA, image2[ntime].width,image2[ntime].height, 0,GL_RGBA,GL_UNSIGNED_BYTE,image2[ntime].imageData);
 } else {
   glTexImage2D(GL_TEXTURE_2D,0, GL_RGB, image2[ntime].width,image2[ntime].height, 0,GL_RGB,GL_UNSIGNED_BYTE,image2[ntime].imageData);
 }
 

  // glTexImage2D(GL_TEXTURE_2D,0, GL_RGBA, image2[ntime].width,image2[ntime].height, 0,GL_RGBA,GL_UNSIGNED_BYTE,image3);
	
  // ボタンテクスチャの設定
  if (int_button != 0) {
    glGenTextures(NUMBER_ICON_TEXTURE_FILE,icontexName);
		
		
    for (int i = 0; i< NUMBER_ICON_TEXTURE_FILE; i++) {
						
      if ( icontexName[i] != NULL){
	glBindTexture(GL_TEXTURE_2D,icontexName[i]);
			
	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
	//GL_NEARESTは近くの値を採用する。GL_NEARESTは双線形補完
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); 
	// glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);		
	/* テクスチャの繰り返し方法の指定 */
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP); 
	//	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL); //下地の色とブレンドしない
	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE); //下地の色とブレンド
			
	
	glTexImage2D(GL_TEXTURE_2D, 0,GL_RGBA, icon[i].width,icon[i].height,0, GL_RGBA,GL_UNSIGNED_BYTE,icon[i].imageData);


      }
    }
		
	
    // pushed iconの設定
    glGenTextures(1,&pushed_icontexName);
    glBindTexture(GL_TEXTURE_2D,pushed_icontexName);
			
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
	//GL_NEARESTは近くの値を採用する。GL_NEARESTは双線形補完
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); 
	// glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);		
	/* テクスチャの繰り返し方法の指定 */
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP); 
	//	glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL); //下地の色とブレンドしない
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE); //下地の色とブレンド
			
    glTexImage2D(GL_TEXTURE_2D, 0,GL_RGBA, pushed_icon.width,pushed_icon.height,0, GL_RGBA,GL_UNSIGNED_BYTE,pushed_icon.imageData);
  }
	
}

// テクスチャがあるかないかを確認するルーチン
void fileornot (void )
{

  int n;
  int   nmaxtexture ;
  int istart = 0;
  // 二つ目の惑星のテクスチャが異なる場合

  nmaxtexture = ntimemax;
  for (int i =istart ; i < nmaxtexture;i++){	
    FILE* gazou_f;  
    FILE* logogazou_f;
    char temp[10];
    string str_suffix_tex;
    string str_suffix_screen;
    string strtexname ;
    string strscreenname; 
    n = i+tex_start;
    sprintf(temp,"%d",n) ;
    string temp2 = string(temp);
    strtexname = strtexfile +temp2+ "." +strtexfile_s;
    strscreenname = strscreenfile +temp2+ "." +strscreenfile_s;
    str_suffix_tex = strtexfile_s;
    str_suffix_screen = strscreenfile_s;
   

	
    gazou_f = fopen(strtexname.c_str(), "rb");


    if( gazou_f == NULL ){ // 地球の画像がない場合

      ntimemax=i;


      if (ntimemax ==0 ) 
	{
	  printf("%s\n","No sphere texture file");
	}
      break; // ループを抜ける
    }

/* 2011/07/19 added for Ver. 1.12 by Saito-A */	
    fclose(gazou_f);
/*------------------------------------------------*/
  }
  
    // 二つ目の惑星のテクスチャが異なる場合

 
  
  if (second_sphere_texture == 1){
    FILE* gazou_f;  
    FILE* logogazou_f;
    char temp[10];
    string str_suffix_tex;
    string str_suffix_screen;
    string strtexname ;
    string strscreenname; 

    nmaxtexture = 2*ntimemax;
    istart = ntimemax;
    for (int i =istart ; i < nmaxtexture;i++){
   
      n = i+tex_start -ntimemax;
      sprintf(temp,"%d",n) ;
      string temp2 = string(temp);
      strtexname = strtexfile2 +temp2+ "." +strtexfile_s2;
      strscreenname = strscreenfile2 +temp2+ "." +strscreenfile_s2;
      str_suffix_tex = strtexfile_s2;
      str_suffix_screen = strscreenfile_s2;
    

      gazou_f = fopen(strtexname.c_str(), "rb");
		
  
      if( gazou_f == NULL ){ // 地球の画像がない場合
	ntimemax=i - ntimemax;
	if (ntimemax ==0 ) 
	  {
	    printf("%s\n","No sphere texture file");
	  }
	break; // ループを抜ける
      }

/* 2011/07/19 added for Ver. 1.12 by Saito-A */	
      fclose(gazou_f);
/*------------------------------------------------*/
    }
  }
    
}


int main(int argc, char *argv[])
{
	
  // 初期設定ファイルを読み込む
  char line[32] = "data/conf/lang-";
  if (argc == 2) {
    strncat(line, argv[1], sizeof(line)-strlen(line)-5);
    strcat(line, ".txt");
    init_file[2] = line;
  }
  readinit_file =1;
  func_readinit_file();
  readinit_file =0;
  
  fileornot();

  glutInitWindowSize(pixsize_x, pixsize_y);	
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA);
  glutInitDisplayMode(GLUT_DOUBLE);
  glutInitDisplayMode(GLUT_DEPTH); // 後からの表示が上にならないようにする。

 
  glutInitWindowPosition(0, 0);
  window1 = glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  glutSpecialFunc(spkeyboard);
  /* 透明度の設定 */
  /* 色の合成をするようにする */
  glEnable(GL_BLEND);
 
  
  /* 色の合成方法を指定 */
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  init(window1);

  // 二つ目のウィンドウ 
  if (nsphere == 2) {
    glutInitWindowPosition(pixsize_x, 0);
    window2 = glutCreateWindow(argv[0]);
  
    glutDisplayFunc(display2);
    glutReshapeFunc(resize);
    glutMouseFunc(mouse);
    glutMotionFunc(motion);
    glutKeyboardFunc(keyboard);
    glutSpecialFunc(spkeyboard);
 /* 透明度の設定 */
  /* 色の合成をするようにする */
    glEnable(GL_BLEND);
  /* 色の合成方法を指定 */
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    init(window2);
  }	

  /* コマンドライン引数の解析 */
  // -n ntime -e buff1
  while (--argc) {
    ++argv;
#ifdef MACINTOSH
    if (**argv == '-') {
#else
      if (**argv == '-' || **argv == '/') {
#endif
	++*argv;
	switch (**argv) {
	  // 時間	
	case 'n':
	  //	ntime = atoi(++*argv);
	  ++argv; //次の引数へ
	  --argc; // whileの条件も減らす
	  ntime = atoi(*argv);
	  break;
						
	default:
	  break;
	}
      }
    }
		
    if (fullscreen == 1)    glutFullScreen();
		
#ifdef USE_GLUI
    if (guilevel == 1)  guiglui();
#endif
		
    glutMainLoop();
		
    return 0;
  }
	
	
	
  void texture_change(int num_window)
  {	
    int s = 0;	
    if ( (num_window == window2) && (second_sphere_texture  == 1) ) {
      s = ntimemax;
    }
    glBindTexture(GL_TEXTURE_2D,texName[0]);
 
    glTexImage2D(GL_TEXTURE_2D, 0,GL_RGB, image1[ntime+s].width,image1[ntime+s].height, 0,GL_RGB,GL_UNSIGNED_BYTE,image1[ntime+s].imageData);
	       	

    if (mask_logo[ntime]) {
      glBindTexture(GL_TEXTURE_2D,texName[1]);
  
      if ( screen_front == 1 ){
	glTexImage2D(GL_TEXTURE_2D,0, GL_RGBA, image2[ntime+s].width,image2[ntime+s].height, 0,GL_RGBA,GL_UNSIGNED_BYTE,image2[ntime+s].imageData);
      }else{
	glTexImage2D(GL_TEXTURE_2D,0, GL_RGB, image2[ntime+s].width,image2[ntime+s].height, 0,GL_RGB,GL_UNSIGNED_BYTE,image2[ntime+s].imageData);
      }
    }	
		
		
		
  }
	
  /*
  ** 球の描画
  */
  void sphere(double radius)
  {	
    int i, j,ten;
    double temp;
    double pi= 3.14159265;
    double xtex0,ytex0;	
    double xtex1,ytex1;	
    double xtex2,ytex2;	
    double xtex3,ytex3;		
    double xs0,ys0,zs0;
    double xs1,ys1,zs1;
    double xs2,ys2,zs2;
    double xs3,ys3,zs3;
    int bango;
    double theta0,theta1,theta2,theta3;
    double phi0,phi1,phi2,phi3;
    GLdouble svertex[N_IDO*N_KEIDO][4][3];

    GLdouble stexcoord[N_IDO*N_KEIDO][4][2] ;
    GLdouble snormal[N_IDO*N_KEIDO][3] ;
  
    glColor4fv(white); // テクスチャが透明にならないように。

    bango =-1;
    for (j =0;  j <N_KEIDO;++j)
      { 
	for (i =0;  i < N_IDO;++i)
	  { 
	    bango = bango +1;
	    theta0 = pi/N_IDO *i;
	    phi0 = 2*pi/N_KEIDO *j;
	    theta1 = pi/ N_IDO *(i+1);
	    phi1 = 2*pi/N_KEIDO *j;
	    theta2 = pi/ N_IDO *(i+1);
	    phi2 = 2*pi/N_KEIDO *(j+1);
	    theta3 = pi/ N_IDO *i;
	    phi3 = 2*pi/N_KEIDO *(j+1);
				
	    // テクスチャの分割
	    ytex0= 1.0/ N_IDO*i;
	    xtex0= 1.0/N_KEIDO*j;
	    ytex1= 1.0/ N_IDO*(i+1);
	    xtex1= 1.0/N_KEIDO*j;
	    ytex2= 1.0/ N_IDO*(i+1);
	    xtex2= 1.0/N_KEIDO*(j+1);
	    ytex3= 1.0/ N_IDO*i;
	    xtex3= 1.0/N_KEIDO*(j+1);
				
	    xs0	= radius*sin(theta0)*cos(phi0);
	    ys0	= radius*sin(theta0)*sin(phi0);
	    zs0	= radius*cos(theta0);
				
	    xs1	= radius*sin(theta1)*cos(phi1);
	    ys1	= radius*sin(theta1)*sin(phi1);
	    zs1	= radius*cos(theta1);
				
	    xs2	= radius*sin(theta2)*cos(phi2);
	    ys2	= radius*sin(theta2)*sin(phi2);
	    zs2	= radius*cos(theta2);
				
	    xs3	= radius*sin(theta3)*cos(phi3);
	    ys3	= radius*sin(theta3)*sin(phi3);
	    zs3	= radius*cos(theta3);
				
	    svertex[bango][0][0] = xs0 ;
	    svertex[bango][0][1] = ys0 ;
	    svertex[bango][0][2] = zs0 ;
	    stexcoord[bango][0][0] =  xtex0; 	
	    stexcoord[bango][0][1] =   ytex0; 
				
	    svertex[bango][1][0] = xs1 ;
	    svertex[bango][1][1] = ys1 ;
	    svertex[bango][1][2] = zs1 ;
	    stexcoord[bango][1][0] =  xtex1; 	
	    stexcoord[bango][1][1] =  ytex1; 
				
	    svertex[bango][2][0] = xs2 ;
	    svertex[bango][2][1] = ys2 ;
	    svertex[bango][2][2] = zs2 ;
	    stexcoord[bango][2][0] =  xtex2; 	
	    stexcoord[bango][2][1] =  ytex2; 
				
	    svertex[bango][3][0] = xs3 ;
	    svertex[bango][3][1] = ys3 ;
	    svertex[bango][3][2] = zs3 ;
	    stexcoord[bango][3][0] =  xtex3; 	
	    stexcoord[bango][3][1] =  ytex3; 
				
	    // 法線ベクトルを計算する
	    snormal[bango][0] = (ys1-ys0)*(zs2-zs0) - (zs1-zs0)*(ys2-ys0);
	    snormal[bango][1] = -(xs1-xs0)*(zs2-zs0) + (xs2-xs0)*(zs1-zs0);
	    snormal[bango][2] = (xs1-xs0)*(ys2-ys0) - (ys1-ys0)*(xs2-xs0);
	    temp =  sqrt(pow(snormal[bango][0],2) + pow(snormal[bango][1],2) + pow(snormal[bango][2],2));
				
	    snormal[bango][0]= snormal[bango][0]/temp;
	    snormal[bango][1]= snormal[bango][1]/temp;
	    snormal[bango][2]= snormal[bango][2]/temp;
				
	  }
      }
		
    glBegin(GL_QUADS);
		
    for (bango = 0; bango < N_IDO*N_KEIDO; ++bango) {
      glNormal3dv(snormal[bango]);
      for (ten = 0; ten < 4; ++ten) {
	/* テクスチャ座標の指定 */
	glTexCoord2dv(stexcoord[bango][ten]);
	/* 対応する頂点座標の指定 */
	glVertex3dv(svertex[bango][ten]);
      }	



    }
    glEnd();

    if (isenkeisenornot) {
    // 緯線、経線の表示
      glDisable(GL_TEXTURE_2D);
      glColor4fv(color_isenkeisen);
      GLdouble kakudai = LINE_KAKUDAI;
      int bango2 = 0;
      glScalef(kakudai,kakudai,kakudai);
      if ( (glutGetWindow() == window1) || (synch == 1)){
	glLineWidth(scale_factor*line_width); // 線の太さの調整
      } else {
	glLineWidth(scale_factor2*line_width); // 線の太さの調整
      }
    //経線の表示
      glBegin(GL_LINES);
      for (bango2 = 0; bango2 < N_KEIDO; bango2 = bango2 + N_KEIDO/num_keisen) { 
	for (bango = bango2*N_IDO; bango <  (bango2+1)*N_IDO; ++bango) {
	  for (ten = 0; ten < 2; ++ten) {
	    glVertex3dv(svertex[bango][ten]);
	  }
	}
      }
     
    //緯線の表示
  
      for (bango = 0; bango <  N_KEIDO*N_IDO; bango = bango + N_IDO/num_isen) {
	
	if (  bango%(N_IDO)  != N_IDO/2 ) {
	  glVertex3dv(svertex[bango][0]);
	  glVertex3dv(svertex[bango][3]);
	}

      }
      glEnd(); 

      // 赤道の描画
      glColor4fv(color_sekidou);
      if ( (glutGetWindow() == window1) || (synch == 1)){
	glLineWidth(scale_factor*line_width_red); // 線の太さの調整
      }else {
	glLineWidth(scale_factor2*line_width_red); // 線の太さの調整
      }
      glBegin(GL_LINES);  
      
      for (bango = 0; bango <  N_KEIDO*N_IDO; bango = bango + N_IDO/2) {

	glVertex3dv(svertex[bango][0]);
	glVertex3dv(svertex[bango][3]);
	

      }
      glEnd(); 

    
      glEnable(GL_TEXTURE_2D);
      glScalef(1.0/kakudai,1.0/kakudai,1.0/kakudai);
    }
  }
