
#pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

#include <iostream>
#include <fstream>
#include <string>



#include "ckkparam.h"
using namespace std;



// 初期設定ファイルを読み込むルーチン
void func_readinit_file(void)
{
	
  for (int i = 0; i < 3; i++){
    ifstream ifs( init_file[i] );
    if (ifs.is_open()) { /* チェック！*/
			
			
      string str;
			
      while (	ifs >> str) { // strをよめる限り読み続ける
				
	if (str == "#AnimationSpeed") { 
	  ifs >> animsokudo ;
	} else if (str == "#StopAt1stMap") { 
	  ifs >> anim_duration;
	} else if (str == "#SpinSpeed") { 
	  ifs >> jitensokudo ;
	} else if (str == "#FullScreen") { 		
	  ifs >> fullscreen ;
	  if ( (  fullscreen > 1 ) || (   fullscreen < 0 )) {  fullscreen =0; }
	  if (  fullscreen  == 1) glutFullScreen();
	} else if (str == "#Spin") { 
	  ifs>>  jitenornot ;
	  if ( (  jitenornot> 1 ) || (   jitenornot < 0 )) {  jitenornot =0; }
	} else if (str == "#Repeat") { 
	  ifs >> stopornot;
	  if ( (   stopornot > 1 ) || (   stopornot < 0 )) {  stopornot =0; }
	} else if (str == "#Animation") { 
	  ifs >> anim;
	  if ( (   anim > 1 ) || (  anim < -1 )) { anim =0; }
	} else if (str == "#Latitude") { 
	  ifs >> rad_latitude ;
	  rad_latitude = 3.14159265359*(90.0 - rad_latitude)/180.0 ; // 北極が緯度ゼロの座標系に変換
	} else if (str == "#Longitude") { 
	  ifs >> rad_longitude;
	  rad_longitude = 3.14159265359*(rad_longitude+180.0)/180.0 ; //テクスチャの端が経度ゼロの座標系に変換
	} else if (str == "#Latitude2") { 
	  ifs >> rad_latitude2 ;
	  rad_latitude2 = 3.14159265359*(90.0 - rad_latitude2)/180.0 ; // 北極が緯度ゼロの座標系に変換
	} else if (str == "#Longitude2") { 
	  ifs >> rad_longitude2;
	  rad_longitude2 = 3.14159265359*(rad_longitude2+180.0)/180.0 ; //テクスチャの端が経度ゼロの座標系に変換
	} else if (str == "#WindowSizeXY") { 
	  ifs >> pixsize_x;
	  ifs >> pixsize_y;
	} else if (str == "#Perspective") { 	
	  ifs >> perspec ;
	  if ( (  perspec > 1 ) || (  perspec < 0 )) { perspec =0; }
	} else if (str == "#EyePosition") { //視点の位置
	  ifs >> ez ;
	} else if (str == "#Scale") { 
	  ifs >> init_scale_factor ;
	  if (init_scale_factor > ez - nearlimit) init_scale_factor = ez-nearlimit;
	  scale_factor = init_scale_factor;
	} else if (str == "#Scale2") { 
	  ifs >> init_scale_factor2 ;
	  if (init_scale_factor2 > ez - nearlimit) init_scale_factor = ez-nearlimit;
	  scale_factor2 = init_scale_factor2;
	} else if (str == "#EarthXY") { 	
	  ifs >> trans_x ;	
	  ifs >> trans_y ;
	  trans[0] = trans_x;
	  trans[1] = trans_y;
	} else if (str == "#NumberOfEarth") { 	
	  ifs >> nsphere ;
	  if ( (  nsphere > 2 ) || (  nsphere < 1 )) { nsphere =1; }
	} else if (str == "#EarthSizeSynch") { 	
	  ifs >> synch ;
	  if ( (  synch > 2 ) || (  synch < 0 )) { synch =1; }
	} else if (str == "#EarthRotationSynch") { 	
	  ifs >> rotsynch ;
	  if ( (  rotsynch > 2 ) || (  rotsynch < 0 )) { rotsynch =1; }
	} else if (str == "#TextureOfEarth2") { 	
	  ifs >> second_sphere_texture ;
	  if ( (  second_sphere_texture > 2 ) || (  second_sphere_texture < 1 )) { second_sphere_texture =0; }
	} else if (str == "#Earth2XY") { 	
	  ifs >> trans_x2 ;	
	  ifs >> trans_y2 ;
	  trans[0] = trans_x;
	  trans[1] = trans_y;
	} else if (str == "#Earth2AngleAxisXY") { 	
	  ifs >> angle2 ;	
	  ifs >> angle_axis2[0] ;
	  ifs >> angle_axis2[1] ;
	} else if (str == "#ScreenScaleXY") { 
	  ifs >> logo_scale ;	
	  ifs >> logo_x ;	
	  ifs >> logo_y ;
	} else if (str == "#ScreenFront") { 
	  ifs >> screen_front ;	
	  if ( (  screen_front > 1 ) || ( screen_front < 0 )) { screen_front =0; }
	} else if (str == "#TimebarScaleXY") { 
	  ifs >> time_scale ;	
	  ifs >> time_x ;	
	  ifs >> time_y ;
	} else if (str == "#InertiaOfRotation") { 
	  ifs >> minkanseikaiten ;
	  ifs >> minkanseikaitenstop ;
	  ifs >>  strengthkanseikaiten ;
	  ifs >> gensuikanseikaiten ;
	} else if (str == "#InvisibleCursor") { 
	  ifs >> invisible_cursor ;
	  if ( (  invisible_cursor > 1 ) || (  invisible_cursor < 0 )) { invisible_cursor =0; }
	} else if (str == "#SpinIntervalSecond") { 
	  ifs >> jiten_speed ;	
	} else if (str == "#MeridianLatitude") { 
	  ifs >> isenkeisenornot ;
	  if ( (  isenkeisenornot > 1 ) || (   isenkeisenornot < 0 )) {  isenkeisenornot =0; }
	  ifs >> num_keisen;
	  ifs >> num_isen;
	  ifs >> line_width;
	  ifs >>line_width_red;
	} else if (str == "#ColorMeridianLatitude") { 
	  ifs >> color_isenkeisen[0];
	  ifs >> color_isenkeisen[1];
	  ifs >> color_isenkeisen[2];
	  ifs >> color_isenkeisen[3];
	  ifs >> color_sekidou[0];
	  ifs >> color_sekidou[1];
	  ifs >> color_sekidou[2];
	  ifs >> color_sekidou[3];
	} else if (str == "#Icon") { 
	  ifs >> int_button ;
  //	printf("%d \n",int_button);
	  if ( ( int_button > NUMBER_ICON ) || ( int_button < 0 )) {int_button =0; }
	}  else if (str == "#IconScaleXY") {
	  icon_onoff[0]=1;
	  ifs >> icon_scale[0];
	  ifs >> icon_posi_x[0] ;
	  ifs >> icon_posi_y[0] ;
	}  else if (str == "#Icon2ScaleXY") { 
	  icon_onoff[1]=1;					
	  ifs >> icon_scale[1];
	  ifs >> icon_posi_x[1] ;
	  ifs >> icon_posi_y[1] ;
	}	else if (str == "#Icon3ScaleXY") {
	  icon_onoff[2]=1;	
	  ifs >> icon_scale[2];
	  ifs >> icon_posi_x[2] ;
	  ifs >> icon_posi_y[2] ;
	}	else if (str == "#Icon4ScaleXY") { 
	  icon_onoff[3]=1;
	  ifs >> icon_scale[3];
	  ifs >> icon_posi_x[3] ;
	  ifs >> icon_posi_y[3] ;
	} else if (str == "#Icon5ScaleXY") {
	  icon_onoff[4]=1;	
	  ifs >> icon_scale[4];
	  ifs >> icon_posi_x[4] ;
	  ifs >> icon_posi_y[4] ;
	}	else if (str == "#Icon6ScaleXY") { 
	  icon_onoff[5]=1;
	  ifs >> icon_scale[5];
	  ifs >> icon_posi_x[5] ;
	  ifs >> icon_posi_y[5] ;
	}	else if (str == "#Icon7ScaleXY") { 
	  icon_onoff[6]=1;
	  ifs >> icon_scale[6];
	  ifs >> icon_posi_x[6] ;
	  ifs >> icon_posi_y[6] ;
	}	else if (str == "#Icon8ScaleXY") { 
	  icon_onoff[7]=1;
	  ifs >> icon_scale[7];
	  ifs >> icon_posi_x[7] ;
	  ifs >> icon_posi_y[7] ;
	}	else if (str == "#Icon9ScaleXY") { 
	  icon_onoff[8]=1;
	  ifs >> icon_scale[8];
	  ifs >> icon_posi_x[8] ;
	  ifs >> icon_posi_y[8] ;
	}  else if (str == "#Icon10ScaleXY") { 
	  icon_onoff[9]=1;
	  ifs >> icon_scale[9];
	  ifs >> icon_posi_x[9] ;
	  ifs >> icon_posi_y[9] ;
	}  else if (str == "#Icon11ScaleXY") { 
	  icon_onoff[10]=1;
	  ifs >> icon_scale[10];
	  ifs >> icon_posi_x[10] ;
	  ifs >> icon_posi_y[10] ;
	}  else if (str == "#Icon12ScaleXY") { 
	  icon_onoff[11]=1;
	  ifs >> icon_scale[11];
	  ifs >> icon_posi_x[11] ;
	  ifs >> icon_posi_y[11] ;
	}  else if (str == "#Icon13ScaleXY") { 
	  icon_onoff[12]=1;
	  ifs >> icon_scale[12];
	  ifs >> icon_posi_x[12] ;
	  ifs >> icon_posi_y[12] ;
	}  else if (str == "#Icon14ScaleXY") { 
	  icon_onoff[13]=1;
	  ifs >> icon_scale[13];
	  ifs >> icon_posi_x[13] ;
	  ifs >> icon_posi_y[13] ;
	} else if (str == "#TextureName") { 
	  ifs >> strtexfile ;
	} else if (str == "#TextureSuffix") { 
	  ifs >> strtexfile_s ;
	}  else if (str == "#ScreenName") { 
	  ifs >> strscreenfile ;
	} else if (str == "#ScreenSuffix") { 
	  ifs >> strscreenfile_s ;
	} else if (str == "#TextureName2") { 
	  ifs >> strtexfile2 ;
	} else if (str == "#TextureSuffix2") { 
	  ifs >> strtexfile_s2 ;
	}  else if (str == "#ScreenName2") { 
	  ifs >> strscreenfile2 ;
	} else if (str == "#ScreenSuffix2") { 
	  ifs >> strscreenfile_s2 ;
	} else if (str == "#TextureStart") { 
	  ifs >> tex_start ;
	} else if (str == "#TextureEnd") { 
	  ifs >> tex_end ;
	}
 
      }
    }
    if (nsphere == 1)  { second_sphere_texture = 0; }
    ifs.close();  // 閉じる
  }
  
 
   /* ズレ回転行列の初期化 */
  double r1[3] = {angle_axis2[0],angle_axis2[1],0.0};
  double rad_angle2 = angle2/180.0*3.1415926535897932384626433;
  qzure[0] = cos(rad_angle2*0.5);
  qzure[1] = r1[0]*sin(rad_angle2*0.5);
  qzure[2] = r1[1]*sin(rad_angle2*0.5);
  qzure[3] = r1[2]*sin(rad_angle2*0.5);
  qzure_inv[0] = cos(-rad_angle2*0.5);
  qzure_inv[1] = r1[0]*sin(-rad_angle2*0.5);
  qzure_inv[2] = r1[1]*sin(-rad_angle2*0.5);
  qzure_inv[3] = r1[2]*sin(-rad_angle2*0.5);
}
